package org.ccgv.text.gate;
import java.text.SimpleDateFormat;
import java.util.*;
import java.io.*;
import java.net.*;

import gate.util.persistence.PersistenceManager;
import gate.corpora.RepositioningInfo;
import gate.creole.*;
import gate.*;
import gate.util.*;

import com.google.gson.JsonObject;

import org.apache.commons.codec.binary.Base64;
import org.ccgv.text.gate.util.*;
import org.ccgv.text.resource.api.PubmedDataInterface;
//import org.ccgv.text.gate.GateParser.SortedAnnotationList;
import org.ccgv.text.gate.HtmlModel.startEndFlagEnum;
import org.ccgv.text.gate.pattern.CarreRule;
import org.ccgv.text.gate.pattern.HotmapRule;
import org.ccgv.text.gate.jape.JapeKeywords;
import org.ccgv.text.gate.jape.JapeMain;
import org.ccgv.text.model.Citation;
import org.ccgv.text.model.Extraction;
import org.ccgv.text.model.db.TextDocModel;
import org.ccgv.text.util.DBAccess;
import org.ccgv.text.util.ListManager;
import org.ccgv.text.util.JavaEnumSwitchCaseExample.Blah;
import org.ccgv.text.clearnlp.*;
import org.lightcouch.Attachment;
import org.lightcouch.Response;

//http://gate.ac.uk/wiki/code-repository/src/sheffield/examples/StandAloneAnnie.java
public class GateExtractor {
	
	private CorpusController annieController;
	//@Value("${ontologyFile}")
	private String ontologyFile;
	//@Value("${grammarFile}")
	private String grammarFile;
	//@Value("${pluginsHome}")
	private String pluginsHome;
	//@Value("${htmlDir}")
	private String htmlDir;
	//@Value("${tohtmlUrl}")
	private String tohtmlUrl;
	//@Value("${highlighted}")
	private String highlighted;
	//@Value("${gateHome}")
	private String gateHome;
	//@Value("${uploadDir}")
	private String uploadDir;
	//@Value("${googleCustomSearchKey}")
	private String googleSearchKey;
	
	private String dicFile;
	private String dics;
	private static int testCount = 1;
	//private static String currentUuid;
	

	private static GateExtractor instance = null;
	private static Hashtable grpTagsWithColour = null;
	private Corpus corpus = null;
	private String keywords;
	EnumProject project;
	private String testUrl;
	
	int[] summary = {0,0,0,0};
	private Hashtable grpedColourTable;
	public enum EnumProject{
				Carre {
				      public String toString() {
				          return "Carre";
				      }},
				Hotmap{
					  public String toString() {
					          return "Hotmap";
					  }},
				Chic,Div}
	public  enum FileNameEnum {TagFile, ResultFile};
	
	public enum EnumMode{standalong,web}
	private EnumMode mode;
	
	public GateExtractor(String grammar,String keywords,EnumMode mode){
		this.keywords = keywords;
		if(grammar !=null && !grammar.equals("")){
			this.grammarFile = CommonMethod.getKeywordsJapePath(mode) + grammar;
		}
		CommonMethod.screenPrint("from GateExtract ,\n ,this.grammarFile="+this.grammarFile+"\n ");
		this.mode = mode;
		
	}

	//onto and dic read from cfg file
	public GateExtractor(String grammar,String keywords){//d:/work/Gate/myProject/gateProject/ontology
		//pluginsHome = "D:"+File.separator+"tools"+File.separator+"Gate"+File.separator+"gate-7.0-build4195-BIN"+File.separator+"plugins";
		this.keywords = keywords;
		this.grammarFile = CommonMethod.getKeywordsJapePath(mode) + grammar;
		CommonMethod.screenPrint("from GateExtract ,\n ,this.grammarFile="+this.grammarFile+"\n ");
		//----------
		//init();
		
		//ontologyFile = "D:"+File.separator+"work"+File.separator+"Gate"+File.separator+"myProject"+File.separator+"gateProject"+File.separator+"ontology"+File.separator+"ComputerGraphics.owl";
		//grammarFile = "D:"+File.separator+"work"+File.separator+"Gate"+File.separator+"myProject"+File.separator+"gateProject"+File.separator+"jape"+File.separator+"keywords1.jape";//"Main_b0eb9251_215c_488f_b039_8d5d544c9707.jape";//"main.jape";//
		//grammarFile = "D:"+File.separator+"work"+File.separator+"Gate"+File.separator+"myProject"+File.separator+"gateProject"+File.separator+"jape"+File.separator+"Main_fb68540a_7fea_4256_a0df_a5752c098a1f.jape";//"main.jape";//"Main_b0eb9251_215c_488f_b039_8d5d544c9707.jape";//"main.jape";//
		//dicFile = "D:"+File.separator+"work"+File.separator+"Gate"+File.separator+"myProject"+File.separator+"gateProject"+File.separator+"dic"+File.separator+"carre"+File.separator+"CarreDomain.def";
		//D:\work\Gate\myProject\gateProject\dic\carre
		//----------
	}
	
	/*public static GateExtractor getInstance() throws GateException, IOException{
		if(instance==null){
			instance = new GateExtractor();
		}
		return instance;
	}*/
	/*
	public void initSerialAnnie(int mode) {
		PipelineBuilder pipe = new PipelineBuilder(mode);
		//Out.prln("Initialising ANNIE...");
		//logger.info("mylogs: Initialising ANNIE...");
		try {
			//annieController = pipe.BuildControllerPipeline0( ontologyFile,grammarFile,dicFile,mode);
			annieController = pipe.BuildControllerPipeLine(grammarFile);
			corpus = Factory.newCorpus("GateParser corpus");
		} catch (ResourceInstantiationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			//throw new GenericException(e.getMessage(), "Back", "dashboard");
		}catch(MalformedURLException ex){
			ex.printStackTrace();
		}
		//Out.prln("...ANNIE loaded");
		//logger.info("mylogs: ANNIE loaded");
	} // initAnnie()
	*/
	
	public void initSerialAnnieNew(String dics) {
		this.dics = dics;
		PipelineFactory pipe = new PipelineFactory(this.mode);
		//Out.prln("Initialising ANNIE...");
		//logger.info("mylogs: Initialising ANNIE...");
		try {
			//annieController = pipe.BuildControllerPipeline0( ontologyFile,grammarFile,dicFile,mode);
			annieController = pipe.AssembleProcessingResource(dics, grammarFile,this.mode);
			corpus = Factory.newCorpus("GateParser corpus");
		} catch (ResourceInstantiationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			//throw new GenericException(e.getMessage(), "Back", "dashboard");
		}
	} // initAnnie()

	/** Tell ANNIE's controller about the corpus you want to run on */
	public void setCorpus(Corpus corpus) {
	  annieController.setCorpus(corpus);
	} // setCorpus
	//----used to process tag
	public void setKeywords(String keywords){
		this.keywords = keywords;
	}
	/** Run ANNIE */
	public void execute() throws GateException {
	  //Out.prln("Running ANNIE...");
	  annieController.execute();
	  //Out.prln("...ANNIE complete");
	} // execute()
	

	public void setTestFile(String url){
		this.testUrl = url;
	}
	public String getTestFile(){
		return this.testUrl;
	}

	public  boolean createCorpusDocument(Corpus corpus,String dbType,String resId,String uuid) throws MalformedURLException,ResourceInstantiationException {
		//URL u = new URL("http://10.1.62.218:8080/heartFailure.txt");//http://10.1.62.239:8080/jQuery/data/gateTest.html
		//URL fileUrl = new URL("http://10.1.62.239:8080/jQuery/data/gateTest.html");
		//String fileUrl ="http://10.1.62.239:8080/jQuery/data/gateTest.html";
		boolean rtn = false;
		String sUrl = null;
		//String uuid = null;
		if(resId!=null){
			rtn = createTaggedFileDB(dbType,resId,uuid);//return uuid
		}
		
        if(rtn){
        	sUrl = GateExtractor.getTagFileURL(uuid);
        	//sUrl = GateExtractor.getTmpFileURL(uuid);
        	//sUrl = GateExtractor.getTmpFileURLByName("testDomainOnto.html"); //@todo for test
        }
        CommonMethod.screenPrint("in GateExtractor createCorpusDocument sUrl>>>>>>>>>>>>>:"+sUrl);
        if(this.mode == EnumMode.standalong){
        	//sUrl = "http://localhost:8080/InfoMining/tmpTagFile/testSentenceChic.html";
        	sUrl = getTestFile();
        	CommonMethod.screenPrint("sUrl:"+sUrl);
        }
        
        //sUrl = "http://localhost:8080/Carre/tmpTagFile/testSentenceChic.html";//for test @todo
        //sUrl = "http://localhost:8080/jQuery/tmpTagFile/tmp_b4a167e8_9f8c_4163_817f_c82b3e48415d.html";// for test @todo
        if(sUrl !=null){
			FeatureMap params = Factory.newFeatureMap();
			params.put("sourceUrl", sUrl);//file url
			params.put("preserveOriginalContent", new Boolean(true));
			params.put("collectRepositioningInfo", new Boolean(true));
			params.put("markupAware", new Boolean(true));
			params.put("encoding", "UTF-8"); 
			
			//Out.prln("Creating doc for " + u);
			Document tmpDoc = (Document)Factory.createResource("gate.corpora.DocumentImpl", params);
			//CommonMethod.screenPrint("uuid in document:"+tmpDoc.getParameterValue("uuid"));
			corpus.add(tmpDoc);
			
        }
        return rtn;
	}
	public static boolean createResultFileDB(String uuid,Attachment attachment){
		boolean rtn = false;
		DBAccess dbA = new DBAccess();
		rtn = dbA.updateAcademyAttachment(uuid, attachment, FileNameEnum.ResultFile.toString()+".html");
		
		return rtn;
	}
	public static boolean createTaggedFileDB(String dbType,String resId,String uuid){
		boolean rtn = false;
		DBAccess dbA = new DBAccess();
		
		TextDocModel tdModel = new TextDocModel(uuid,dbType);//uuid as id
		tdModel.setResId(resId);

		CommonMethod.screenPrint("in createTaggedFileDB get pro direct from : resId:"+tdModel.getResId()+",docId:"+tdModel.getId()+",dbType:"+tdModel.getDocType());
		String docId = dbA.insertAcademyDocument(tdModel);
		//--------tag file Attachment
		StringBuffer tmpFile = new StringBuffer();
		String fileContent = "";
		 
		//dbtype 
		CommonMethod.screenPrint("in GateExtract createTaggedFile before processFetchAbstract");
		PubmedDataInterface pubmed = new PubmedDataInterface();
		try {
			tmpFile.append("<p>");
			fileContent = pubmed.processFetchAbstract(resId).toString();
			
			tmpFile.append(fileContent);
			
			CommonMethod.screenPrint("*************fileContent from GateExtractor:"+fileContent);

			tmpFile.append("</p>");
			
			byte[] bytes = String.valueOf(tmpFile).getBytes();
			String data = Base64.encodeBase64String(bytes);
			Attachment attachment = new Attachment(data, "text/plain");	
			//Bar bar = new Bar(); 
			dbA.updateAcademyAttachment(docId, attachment, FileNameEnum.TagFile.toString()+".html");
			rtn = true;
		} catch (Exception e) {
			e.printStackTrace();
		}
		return rtn;
	}
	//return generated file id
	public static boolean createTaggedFile(String dbType,String resId,String uuid){
		boolean rtn = false;
		CommonMethod.screenPrint("in GateExtractor createTaggedFile id:"+resId);
		StringBuffer tmpFile = new StringBuffer();
		String fileContent = "";
		 
		//dbtype 
		CommonMethod.screenPrint("in GateExtract createTaggedFile before processFetchAbstract");
		PubmedDataInterface pubmed = new PubmedDataInterface();
		try {
			tmpFile.append("<p>");
			fileContent = pubmed.processFetchAbstract(resId).toString();
			
			tmpFile.append(fileContent);
			tmpFile.append("</p>");
			
			CommonMethod.screenPrint("in GateExtract createTaggedFile after processFetchAbstract");
			String absFileName = getTmpAbsFileName(uuid);//"tmp_"+uuid+".html";
			//String absFileName = tmpPath+fileName;
			CommonMethod.screenPrint("in GateExtractor createTaggedFile fileName:"+absFileName);
			File file = new File(absFileName);
			FileWriter writer = new FileWriter(file);
		    writer.write(tmpFile.toString());
		    writer.close();
		    rtn = true;
		    
		} catch (Exception e) {
			e.printStackTrace();
		}
		return rtn;
	}
	public static String getTmpAbsFileName(String uuid){
		String tmpPath = CommonMethod.readProperties().getProperty(CommonMethod.TmpFilePath).trim();
		String rtn = tmpPath+"tmp_"+uuid+".html";
		return rtn;
	}
	public static String getTmpFileURLByName(String filename){
		String tmpUrl = CommonMethod.getPropertyValue(CommonMethod.TmpFileURL);
		String rtn = tmpUrl+filename;
		return rtn;
	}
	public static String getTmpFileURL(String uuid){
		String tmpUrl = CommonMethod.readProperties().getProperty(CommonMethod.TmpFileURL).trim();
		String rtn = tmpUrl+"tmp_"+uuid+".html";
		return rtn;
	}
	public static String getTagFileURL(String uuid){
		String tagUrl = CommonMethod.getProperty(CommonMethod.DBURL);
		CommonMethod.screenPrint("in getTagFileURL:"+tagUrl);
		String rtn = tagUrl +uuid+"/"+ FileNameEnum.TagFile.toString()+".html";
		CommonMethod.screenPrint("in getTagFileURL rtn:"+rtn);
		return rtn;
	}
	public static String getResultFileURL(String uuid){
		String tagUrl = CommonMethod.getProperty(CommonMethod.DBURL);
		CommonMethod.screenPrint("in getResultFileURL:"+tagUrl);
		String rtn = tagUrl +uuid+"/"+ FileNameEnum.ResultFile.toString()+".html";
		CommonMethod.screenPrint("in getResultFileURL rtn:"+rtn);
		return rtn;
	}	
	public static String getResultFileNameFromTmp(String tmpUrl){
		String rtn = null;
		
		String lastPart = tmpUrl.substring(tmpUrl.lastIndexOf("/")+1);
		lastPart = lastPart.replace("tmp_", "result_");
		rtn = lastPart;
		return rtn;
	}
	public static String getResultAbsFileName(String uuid){
		String resultPath = CommonMethod.readProperties().getProperty(CommonMethod.ResultFilePath).trim();
		String rtn = resultPath+"result_"+uuid+".html";
		return rtn;
	}
	

	public String getDics(){
		return this.dics;
	}
	

	
	//return result file abs path
	public String processDoc(Corpus corpus,EnumProject project, int loop) throws IOException,Exception {
		this.project = project;
		// for each document, get an XML document with the
		// person and location names added
		String rtn = null;//return new generated result fileName
		Iterator docIter = corpus.iterator();
		int count = 0;
		String startTagPart_1 = "<span GateID=\"";
		String startTagPart_2 = "\" title=\"";
		String startTagPart_3 = "\" style=\"background:Red;\">";
		String endTag = "</span>";
		
		grpedColourTable = RandomColour.getGrpTagsWithColour(this.keywords,project);//generate colour table for further use
		//getRequiredTags
		HashSet annotTypesRequired = getTagsForAnnotationSet(); //include domainTags and keywordTags
		
		//loop files
		while(docIter.hasNext()) {
		    Document doc = (Document) docIter.next();
		    AnnotationSet defaultAnnotSet = doc.getAnnotations();
		    Set<Annotation> annos = new HashSet<Annotation>(defaultAnnotSet.get(annotTypesRequired));

		    FeatureMap features = doc.getFeatures();
		    String originalContent = (String)features.get(GateConstants.ORIGINAL_DOCUMENT_CONTENT_FEATURE_NAME);
		    RepositioningInfo info = (RepositioningInfo)features.get(GateConstants.DOCUMENT_REPOSITIONING_INFO_FEATURE_NAME);
		
		    ++count;
		    
		   // Out.prln("File name: '"+file.getAbsolutePath()+"'");
		    
		    if(originalContent != null && info != null) {

		    	//Out.prln("OrigContent and reposInfo existing. Generate file...");	
		    	Iterator annosIt = annos.iterator();
		    	Annotation currAnnot;
		    	SortedAnnotationList sortedAnnotations = new SortedAnnotationList(info);
		    	int testCount = 0;
		    	long tmpAnnotStart,tmpAnnotEnd;
		    	while(annosIt.hasNext()) {
		    		currAnnot = (Annotation) annosIt.next();
		    		//---------test---------
				     //tmpAnnotStart = currAnnot.getStartNode().getOffset().longValue();
				     // tmpAnnotStart = info.getOriginalPos(tmpAnnotStart);
				      
				     // tmpAnnotEnd = currAnnot.getEndNode().getOffset().longValue();
				     // tmpAnnotEnd = info.getOriginalPos(tmpAnnotEnd, true);

				     // String tmpContent = originalContent.substring((int)tmpAnnotStart,(int)tmpAnnotEnd);
			        //CommonMethod.screenPrint("in SortedAnnotationList:__________***_________start:"+tmpAnnotStart+",end:"+tmpAnnotEnd+",content:"+tmpContent);
			        //----------test---------------
		    		testCount++;
		    		sortedAnnotations.addSortedExclusive(currAnnot);
		    	} // while
		    	CommonMethod.screenPrint("testCount:"+testCount);
		    	StringBuffer editableContent = new StringBuffer(originalContent);
		    	
		    	//add tags in the content and extract knowledge from special tags
		    	boolean tagFlag =  tagAnnotation(sortedAnnotations,editableContent,info);
		    	
		    	
		    	boolean tagNameFlag = nameTags(editableContent);//add checkbox in the result
		    	String resultURL = "";
		    	//String resultFilePath = CommonMethod.readProperties().getProperty(CommonMethod.ResultFilePath).trim();
		    	try {
					String sUrl = doc.getParameterValue("sourceUrl").toString();//to Get tmp Name, URL of the file in DB
					CommonMethod.screenPrint("sUrl:"+sUrl);
					String docId = getDocIDByUrl(sUrl);//DBURL
					
					//boolean flag =GenerateResultFile.generateResultTemplateFileDB(editableContent,docId);
					boolean flag =GenerateResultFile.generateResultFileDB(editableContent,docId);
					if(flag){
						resultURL = this.getResultFileURL(docId);
					}
					/*
					String resultPath = CommonMethod.readProperties().getProperty(CommonMethod.ResultFilePath).trim();
					CommonMethod.screenPrint("resultPath:"+resultPath);
					String resultFileName = GateExtractor.getResultFileNameFromTmp(sUrl);
					CommonMethod.screenPrint("resultFileName:"+resultFileName);
					String absResult = resultPath +resultFileName;
					CommonMethod.screenPrint("absResult:"+absResult);
					GenerateResultFile.generateResultTemplatedFile(editableContent,absResult);
					*/
			    	/*CommonMethod.screenPrint("resultFile:"+absResult);
			    	File file = new File(absResult);
				    FileWriter writer = new FileWriter(file);
				    writer.write(editableContent.toString());
				    writer.close();*/
				    CommonMethod.screenPrint("in GateExtract processDoc after file write DB in processDoc: "+resultURL);
				    rtn = resultURL;
				    
				} catch (ResourceInstantiationException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}

		    } // if - should generate
		    else if (originalContent != null) {
		     // Out.prln("OrigContent existing. Generate file...");
		    	File file = new File("./filesCreated/tag2_" + loop + ".html");
		      Iterator it = annos.iterator();
		      Annotation currAnnot;
		      SortedAnnotationList sortedAnnotations = new SortedAnnotationList(info);
		
		      while(it.hasNext()) {
		        currAnnot = (Annotation) it.next();
		        //CommonMethod.screenPrint(currAnnot.to);

		        sortedAnnotations.addSortedExclusive(currAnnot);//remove duplicated tag
		      } // while
		
		      StringBuffer editableContent = new StringBuffer(originalContent);
		      //boolean tagFlag =  tagAnnotation(sortedAnnotations,editableContent,info);
		      long insertPositionEnd;
		      long insertPositionStart;
		      // insert anotation tags backward
		      //Out.prln("Unsorted annotations count: "+annos.size());
		      //Out.prln("Sorted annotations count: "+sortedAnnotations.size());
		      for(int i=sortedAnnotations.size()-1; i>=0; --i) {
		        currAnnot = (Annotation) sortedAnnotations.get(i);
		        insertPositionStart =
		          currAnnot.getStartNode().getOffset().longValue();
		        insertPositionEnd = currAnnot.getEndNode().getOffset().longValue();
		        if(insertPositionEnd != -1 && insertPositionStart != -1) {
		          editableContent.insert((int)insertPositionEnd, endTag);
		          editableContent.insert((int)insertPositionStart, startTagPart_3);
		          editableContent.insert((int)insertPositionStart, currAnnot.getType());
		          editableContent.insert((int)insertPositionStart, startTagPart_2);
		          editableContent.insert((int)insertPositionStart,currAnnot.getId().toString());
		          editableContent.insert((int)insertPositionStart, startTagPart_1);
		        } // if
		      } // for
				
		      FileWriter writer = new FileWriter(file);
		      writer.write(editableContent.toString());
		      writer.close();
		      
		    }//else if
		    else {
		     // Out.prln("Content : "+originalContent);
		      //Out.prln("Repositioning: "+info);
		    }//else
		
		    /*String xmlDocument = doc.toXml(annos, false);
		    String fileName = new String("./filesCreated/StANNIE_toXML_" + count + ".HTML");
		    FileWriter writer = new FileWriter(fileName);
		    writer.write(xmlDocument);
		    writer.close();*/
		} // while for each doc
		return rtn;
	}
	
	
	
	//list all tags in group on the file
	/*<p>grp names<p>
	<INPUT TYPE=CHECKBOX NAME="tagName"><span style="color:blue;font-weight:bold">tagName</span><P>
	<INPUT TYPE=CHECKBOX NAME="maillist"><span style="color:blue;font-weight:bold">tagName</span><P>
	<INPUT TYPE=CHECKBOX NAME="maillist"><span style="color:blue;font-weight:bold">tagName</span><P>
	*/
	private boolean nameTags(StringBuffer editableContent){
		boolean rtn = false;
		int idx = editableContent.lastIndexOf("</p>");
		StringBuffer tagStrBuff = new StringBuffer();
		
		//-----------
		//Hashtable tagTable = GateExtractor.getGrpTagsWithColour(this.keywords) ;//only need keys
		String aGrp,aKey,colValue;
		 // Get all values from 3 tables: keywords, domain, onto
	    for (Enumeration grpKeys = this.grpedColourTable.keys(); grpKeys.hasMoreElements();)
	    {
	    	aGrp = (String)grpKeys.nextElement();
	    	tagStrBuff.append("<p><b>"+aGrp+"</b></p>");
			Hashtable subTagTable =(Hashtable) this.grpedColourTable.get(aGrp);//domain table or keyword table
			for(Enumeration tagKeys = subTagTable.keys(); tagKeys.hasMoreElements();){
				aKey = (String)tagKeys.nextElement();
				colValue =(String)subTagTable.get(aKey);
				//   <span GateID="483" style="background:#c0f1b1;">first_aldosteroneTag</span><input type="checkbox" name="tags" class = "first_aldosteroneTag" color ="#c0f1b1" checked="checked" >
				tagStrBuff.append("<input type='checkbox' name='"+aKey+"' class = '"+aKey+"' color ='#"+colValue+"' checked='checked' ><span  style='background:#"+colValue+";'>"+aKey+"</span>");
				//tagStrBuff.append("<INPUT TYPE=CHECKBOX NAME='"+aKey+"'><span style='background:#"+cValue+";font-weight:bold'>"+aKey+"</span><P>");
			}
	    }
	    //---------------
		editableContent.insert( idx, tagStrBuff.toString());
		return rtn;
		
	}

	//tidy up all the tags then insert them in order
	//patternAnalysis result be inserted here
	@SuppressWarnings("unchecked")
	private boolean tagAnnotation(SortedAnnotationList sortedAnnotations, StringBuffer editableContent, RepositioningInfo info)throws Exception
	{
		boolean rtn = false;
		
		//String startTagPart_1 = "<span GateID=\"";
		//String startTagPart_2 = "\" class=\"";
		String endTag = "</span>";
		
		long insertPositionEnd;
		long insertPositionStart;
		
		int annotSize = sortedAnnotations.size();
		
		Annotation currAnnot;
		StringBuffer editableContentCopy = new StringBuffer(editableContent);
		SentenceRelationAnalysis srA ;
		srA = new SentenceRelationAnalysis(project);
		//loop annotations		loop from end to start, start offset big first
		//after loop the Arraylist of htmlTags should be ready
		ArrayList<HtmlModel> htmlList = new ArrayList<HtmlModel>();
		HtmlModel tmpHtmlModel ;
		String anntype,content,tmpId,backGroundStr,strTagStart,strTagEnd,annTmpClass;
		for (int i = annotSize - 1; i >= 0; --i) {//Loop annotation
			currAnnot = (Annotation) sortedAnnotations.get(i);
	        //--------------------deal with this annot
			insertPositionStart = currAnnot.getStartNode().getOffset().longValue();
			insertPositionStart = info.getOriginalPos(insertPositionStart);
			
			insertPositionEnd = currAnnot.getEndNode().getOffset().longValue();
			insertPositionEnd = info.getOriginalPos(insertPositionEnd, true);
		
			//annotation found
			if (insertPositionEnd != -1 && insertPositionStart != -1) {
				//-----process tag
				anntype = currAnnot.getType();//type
				content = editableContentCopy.substring((int)insertPositionStart,(int)insertPositionEnd);//content
				//---------style class-------
				annTmpClass = anntype;
				FeatureMap typeMap = currAnnot.getFeatures();
				String classTmp = (String)typeMap.get("type");
				
				if(classTmp!=null ){
					annTmpClass += " "+ classTmp;
				}

				backGroundStr = RandomColour.getRandomBackground(getTagColour(anntype));//color
				tmpId = currAnnot.getId().toString();//id
				//------------------------------------process known and unknown knowledge-----------
				//CommonMethod.screenPrint("in GateExtractor before collectTag>>>>>>>>>> insertPositionStart="+insertPositionStart+",insertPositionEnd="+insertPositionEnd+",content="+content);
				srA.collectTags(annTmpClass,(int)insertPositionStart,(int)insertPositionEnd,content);
				//---------------------------------------------------------------------
				strTagStart = "<span GateID=\""+tmpId+"\" class=\""+annTmpClass+backGroundStr;
				strTagEnd= "</span>";
				//--------add all the tags in the list----------
				//end model does not need start since end tags are same
				tmpHtmlModel = new HtmlModel();
				tmpHtmlModel.setIndex(insertPositionEnd); //end first
				tmpHtmlModel.setStartEndFlagEnum(startEndFlagEnum.END);
				tmpHtmlModel.setHtmlTag(endTag);
				htmlList.add(tmpHtmlModel);
				//start model need end index
				tmpHtmlModel = new HtmlModel();
				tmpHtmlModel.setIndex(insertPositionStart);//start
				tmpHtmlModel.setHtmlTag(strTagStart);
				tmpHtmlModel.setStartEndFlagEnum(startEndFlagEnum.START);
				tmpHtmlModel.setRefIndex(insertPositionEnd);
				htmlList.add(tmpHtmlModel);
				//---------------list add finished
			}//end of if
		}//end of for annotation	
		//------------sort the htmlTag list 
		ComparatorHtmlTag comparator=new ComparatorHtmlTag();
		Collections.sort(htmlList, comparator);
		//---------------insert ruleList first
		StringBuffer sb = srA.patternAnalysis();
		editableContent.append(sb);//insert rule list from end then insert tags
		//-----------then insert tags in order-------;
		for(int i=0;i<htmlList.size();i++){//list was sorted index big first
			tmpHtmlModel = (HtmlModel)htmlList.get(i);
			editableContent.insert((int) tmpHtmlModel.getIndex(), tmpHtmlModel.getHtmlTag());//insert endTag
		}
		//-------------prepare for linked sentence output--------------
		
		
		return rtn;
	}
	

	
	private String getOntologyFilePathWrite(){
		String sProject = CommonMethod.getProject();
		sProject = sProject.trim();
		CommonMethod.screenPrint("project:"+sProject+",len:"+sProject.length());
		EnumProject theProject = EnumProject.valueOf(sProject);
		String rtn = "";
		String ontologyPath = CommonMethod.getOntologyPathWrite();//include domain name
		rtn = ontologyPath;
		 switch (theProject) {
		    case Carre: 
		    	rtn += "CarreOntology";//ComputerGraphics.owl
		      break;   
		    case Chic: // fall through to C
		    	rtn += "ChicOntology";
		    	break;
		    case Div: 
		    	rtn += "DivOntology";
		      break;
		  }
		 rtn+= ".owl"; 
		 return rtn;
	}
	private String getOntologyFilePathURL(){
		String sProject = CommonMethod.getProject();
		sProject = sProject.trim();
		CommonMethod.screenPrint("project:"+sProject+",len:"+sProject.length());
		EnumProject theProject = EnumProject.valueOf(sProject);
		String rtn = "";
		 rtn = CommonMethod.getOntologyPathURL();//include domainName/
		//String ontologyPath = CommonMethod.readProperties().getProperty(CommonMethod.OntologyPath).trim();
		 switch (theProject) {
		    case Carre: 
		    	rtn += "CarreOntology";//ComputerGraphics.owl
		      break;   
		    case Chic: // fall through to C
		    	rtn += "ChicOntology";
		    	break;
		    case Div: 
		    	rtn += "DivOntology";
		      break;
		  }
		 rtn+= ".owl";
		 return rtn;
	}
	/*private String getGrammarFilePathWrite(String grammarFileName){
		String sJapePath = CommonMethod.getJapePathWrite();
		String rtn = sJapePath + grammarFileName;
		return rtn;
	}
	private String getGrammarFilePathURL(String grammarFileName){
		//String sJapePath = (String)CommonMethod.readProperties().getProperty("JapePath").trim();
		//String rtn = sJapePath + grammarFileName;
		String rtn = CommonMethod.getJapePathURL()+grammarFileName;
		return rtn;
	}*/
	//get project Dic file
	private String getProjectDicFilePathWrite(){
		String sProject = (String)CommonMethod.readProperties().getProperty("Project").trim();
		EnumProject theProject = EnumProject.valueOf(sProject);
		String rtn = "";
		String dicPath = CommonMethod.getDicPathWrite();
		rtn = dicPath ;
		 switch (theProject) {
		    case Carre: 
		    	rtn += "CarreDomain";
		      break;   
		    case Chic: // fall through to C
		    	rtn += "ChicDomain";
		    	break;
		    case Div: 
		    	rtn += "DivDomain";
		      break;
		  }
		 rtn+= ".def";
		 return rtn;
	}

	private String getProjectDicFilePathURL(){
		String sProject = (String)CommonMethod.readProperties().getProperty("Project").trim();
		EnumProject theProject = EnumProject.valueOf(sProject);
		String rtn = "";
		rtn = CommonMethod.getDicPathURL();
		//String dicPath = (String)CommonMethod.readProperties().getProperty("DicPath").trim();
		 switch (theProject) {
		    case Carre: 
		    	rtn += "CarreDomain";
		      break;   
		    case Chic: // fall through to C
		    	rtn += "ChicDomain";
		    	break;
		    case Div: 
		    	rtn += "DivDomain";
		      break;
		  }
		 rtn+= ".def";
		 return rtn;
	}
	

	//only need key from table
	private HashSet getTagsForAnnotationSet(){
		
		HashSet rtn = new HashSet(); //annotTypesRequired
		//-----------
		
		String aKey;
		 // Get all keys
	    for (Enumeration grpKeys = grpedColourTable.keys(); grpKeys.hasMoreElements();)
	    {
			Hashtable subTagTable =(Hashtable) grpedColourTable.get(grpKeys.nextElement());//domain table or keyword table
			for(Enumeration tagKeys = subTagTable.keys(); tagKeys.hasMoreElements();){
				aKey = (String)tagKeys.nextElement();
				//CommonMethod.screenPrint("in getTagsForAnnotationSet:"+aKey+",aKey.length:"+aKey.length());
				rtn.add(aKey);
			}
	    }
	    //-------for test--
	    //rtn.add("Lookup");
		return rtn;
	}
	
	private  String getTagColour(String aTag){
		String rtn = null; //annotTypesRequired
		//-----------
		//Hashtable tagTable = GateExtractor.getGrpTagsWithColour(this.keywords) ;//only need keys
		String aKey;
		 // Get all values
	    for (Enumeration grpKeys = this.grpedColourTable.keys(); grpKeys.hasMoreElements();)
	    {
			Hashtable subTagTable =(Hashtable) this.grpedColourTable.get(grpKeys.nextElement());//domain table or keyword table
			for(Enumeration tagKeys = subTagTable.keys(); tagKeys.hasMoreElements();){
				aKey = (String)tagKeys.nextElement();
				if(aKey.equals(aTag)){
					return (String)subTagTable.get(aKey);
				}
			}
	    }
		return rtn;
	}
//http://10.1.62.239:5984/db-test/a990c3e5_9120_45bc_8496_b6368c0125ca/TagFile.html
	//extract --> a990c3e5_9120_45bc_8496_b6368c0125ca
	private String getDocIDByUrl(String url){
		CommonMethod.screenPrint("in GateExtract getDocIDByUrl: "+url);
		String rtn = null;
		if(url!=null){
			String dbUrl = CommonMethod.getProperty(CommonMethod.DBURL);
			int len = dbUrl.length();
			rtn = url.substring(len, url.lastIndexOf("/"));
			CommonMethod.screenPrint("in GateExtract getDocIDByUrl rtn: "+rtn);
		}else{
			CommonMethod.screenPrint("error: in GateExtract : getDocIDByUrl :url:"+url);
		}
		return rtn;
	}
	public static class SortedAnnotationList extends Vector {
		RepositioningInfo info;
		  public SortedAnnotationList(RepositioningInfo info) {
		    super();
		    this.info = info;
		  } // SortedAnnotationList

		  public boolean addSortedExclusive(Annotation annot) {
			    Annotation currAnot = null;
			    long tmpAnnotStart,orgStart,tmpAnnotEnd,orgEnd,tmpCurrStart,orgCurrStart,tmpCurrEnd,orgCurrEnd; 

			    tmpAnnotStart = annot.getStartNode().getOffset().longValue();
			    orgStart = info.getOriginalPos(tmpAnnotStart);
		     
			    
			    tmpAnnotEnd = annot.getEndNode().getOffset().longValue();
			    orgEnd = info.getOriginalPos(tmpAnnotEnd);
			  
			    //CommonMethod.screenPrint("----------orgStart in--------:"+orgStart+",end:"+orgEnd+",type:"+annot.getType());
			    
			    if(size()==0){
			    	insertElementAt(annot, 0);
			    	//CommonMethod.screenPrint("one annot added start from:"+orgStart+",end:"+orgEnd);
			    }else
			    {
			    	// overlapping check
				    for (int i=0; i<size(); ++i) {
				      currAnot = (Annotation) get(i);
				      //
				      tmpCurrStart = currAnot.getStartNode().getOffset().longValue();
				      orgCurrStart = info.getOriginalPos(tmpCurrStart);
				      tmpCurrEnd = currAnot.getEndNode().getOffset().longValue();
				      orgCurrEnd = info.getOriginalPos(tmpCurrEnd);
				      String currType = currAnot.getType();
				      String annotType = annot.getType();
				      
				      
				      if(annot.overlaps(currAnot) ) 
				      {//sentence nest a tag
				        //if((tmpCurrStart==tmpAnnotStart) || ( (tmpCurrStart-tmpAnnotStart)*(tmpCurrEnd-tmpAnnotEnd)>0)){// totally nest is not overlap but s___________s2___e_____e2 is overlap
				    	  	if((orgCurrStart-orgStart)*(orgCurrEnd-orgEnd)>0){// totally nest is not overlap but s___________s2___e_____e2 is overlap
				    	  		CommonMethod.screenPrint("overlap but not nest start:"+tmpCurrStart);
				    	  		return false;
					        }else if( (orgCurrStart-orgStart)==0 && (orgCurrEnd-orgEnd)==0   ){//start and end same
					        	
					        	FeatureMap typeMap = currAnot.getFeatures();
					        	String tmpType ;
					        	if(!annotType.equalsIgnoreCase(currType)){
						        	if(typeMap.get("type")==null){
						        		tmpType = annot.getType();
						        	}else{
						        		tmpType = typeMap.get("type")+" "+annot.getType();
						        	}
						        	typeMap.put("type", tmpType);
					        	}
					        	
					        	CommonMethod.screenPrint("overlap same start and end:"+tmpCurrStart);
					        	//return false;
					        }else if( (orgCurrStart-orgStart)*(orgCurrEnd-orgEnd)<0){//nest
					        	CommonMethod.screenPrint("nested tag");
					        }
				      } // if
				    } // for
				    //----------insert---------------
				    long annotStart = annot.getStartNode().getOffset().longValue();
				    long currStart;
				    // insert
				    for (int i=0; i < size(); ++i) {
				      currAnot = (Annotation) get(i);
				      currStart = currAnot.getStartNode().getOffset().longValue();
				      if(annotStart <currStart) {
				    	  //CommonMethod.screenPrint("one annot added start from:"+orgStart+",end:"+orgEnd);
				        insertElementAt(annot, i);		  
				       return true;
				      }// if
				    } // for
				    insertElementAt(annot, size());	//add to last
				    //CommonMethod.screenPrint("one annot added start from:"+orgStart+",end:"+orgEnd);
			    }//else, >1
			    return true;
			   } // addSorted
		} // SortedAnnotationList
	
	
	


	
//for training model
public static void main5(String args[]) {
		
		//-----------------parameters begin ---------
		//String keyWords = " heart failure , renal dysfunction constitutes, the cardiorenal syndrome";
		String keyWords = "";
        String dics = "";//"Hotmap,Carre"; //define user selected dics //ICD
        EnumProject project = null;// EnumProject.Hotmap; //Carre
        //String testFile = "http://localhost:8080/InfoMining/tmpTagFile/testSentenceCarre.html";
        String testFile = "http://localhost:8082/InfoMining/tmpTagFile/testSentenceHotmap.html";
		//-----------------parameters over ----------
		
        String executeMode;
		
		try {
			EnumMode mode = EnumMode.standalong;
			CommonMethod.screenPrint("in GateExtractor step1 mode:"+mode);
			GateInstance.getInstance();
			CommonMethod.screenPrint("in GateExtractor step2 GateInstance");
			//------read pattern file first
			
		
			//------read property file next
			//----------init PR 
			PipelineFactory.initProcessingResouces(mode);
			CommonMethod.screenPrint("in GateExtractor step3 initProcessingResouces");
			//----------------
			GateExtractor extObj = new GateExtractor( null,keyWords,mode);//( grammar,keyWords,mode)0 for stand alone
			//extObj.setTestFile(testFile);
			extObj.initSerialAnnieNew(dics);//AssembleProcessingResource
			
			CommonMethod.screenPrint("in GateExtractor step5 initSerialAnnieNew");
			Corpus corpus = Factory.newCorpus("GateParser corpus");
			//corpus.clear();
			//-------create a file----------
			String designView = "paper/paperAttachment";
			//createFile(corpus,null,null);//add file in corpus
			/*boolean flag = extObj.createCorpusDocumentsFromDB(corpus,designView);//dbType temp null
			// tell the pipeline about the corpus and run it
			if(flag){
				extObj.setCorpus(corpus);
				extObj.execute();
				
				String rAbspath = extObj.processDoc(corpus,project,0);//processDoc(corpus,project,0);//0 useless
				
				CommonMethod.screenPrint("\n ...............rAbspath:"+rAbspath);				
			}*/
		} catch (ResourceInstantiationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (GateException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}catch(Exception e){
			e.printStackTrace();
			CommonMethod.screenPrint("Exception from GateExtractor in main4:"+e.getMessage());
		}
		
	}
public static void main4(String args[]) {
		
		//-----------------parameters begin ---------
		//String keyWords = " heart failure , renal dysfunction constitutes, the cardiorenal syndrome";
		String keyWords = "";
        String dics = "Hotmap,Carre"; //define user selected dics //ICD
        //EnumProject project = EnumProject.Carre;
        EnumProject project = EnumProject.Hotmap;
        //String testFile = "http://localhost:8080/InfoMining/tmpTagFile/testSentenceCarre.html";
        //String testFile = "http://localhost:8080/InfoMining/tmpTagFile/testSentenceHotmap.html";
        String testFile = "http://localhost:8080/InfoMining/tmpTagFile/testSentenceHotmap.html";
		//-----------------parameters over ----------
		String userName = "userName";
		String nodeName = "nodeName";
		//String resId = "24886432";
		String resId = "24838327";
		
        JapeMain obj = new JapeMain(keyWords,"userName","nodeName");//(analysisKeywords,userName,nodeName);
        String grammarFileName = obj.createMainFile();
        String executeMode;
		
		try {
			EnumMode mode = EnumMode.standalong;
			CommonMethod.screenPrint("in GateExtractor step1 mode:"+mode);
			GateInstance.getInstance();
			CommonMethod.screenPrint("in GateExtractor step2 GateInstance");
			//------read pattern file first
			CarreRule.getInstance();
			HotmapRule.getInstance();
		
			CommonMethod.screenPrint("in GateExtractor step3 rule getInstance");
			//------read property file next
			//----------init PR 
			PipelineFactory.initProcessingResouces(mode);
			CommonMethod.screenPrint("in GateExtractor step4 initProcessingResouces");
			//----------------
			GateExtractor extObj = new GateExtractor( grammarFileName,keyWords,mode);//0 for stand alone
			extObj.setTestFile(testFile);
			extObj.initSerialAnnieNew(dics);
			
			CommonMethod.screenPrint("in GateExtractor step5 initSerialAnnieNew");
			Corpus corpus = Factory.newCorpus("GateParser corpus");
			//corpus.clear();
			//-------create a file----------
			String uuid = CommonMethod.UuidGenerator();
			//createFile(corpus,null,null);//add file in corpus
			boolean flag = extObj.createCorpusDocument(corpus,null, resId,uuid) ;//dbType temp null
			// tell the pipeline about the corpus and run it
			if(flag){
				extObj.setCorpus(corpus);
				extObj.execute();
				
				String rAbspath = extObj.processDoc(corpus,project,0);//0 useless
				
				CommonMethod.screenPrint("\n ...............rAbspath:"+rAbspath);				
			}
		} catch (ResourceInstantiationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (GateException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}catch(Exception e){
			e.printStackTrace();
			CommonMethod.screenPrint("Exception from GateExtractor in main4:"+e.getMessage());
		}
		
	}
	






	public static void main(String args[]) throws GateException, IOException {
		//enumProject.Carre;//Carre ;
		
	     SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.S");
	        try {
	            
	            System.out.println("before: " + dateFormat.format(Calendar.getInstance().getTime()));
	            //main2(args);
	            main4(args);
	            System.out.println("after: " + dateFormat.format(Calendar.getInstance().getTime()));//after: 2014-05-29 14:18:14.387
	        } catch (Exception e) {
	            e.printStackTrace();
	        }	
	}


} // class StandAloneAnnie



/*	public static void main2(String args[]) throws GateException,IOException,Exception{

String keyWords = " heart failure , renal dysfunction constitutes, the cardiorenal syndrome";
String userName = "userName";
String nodeName = "nodeName";
String resId = "25004343";
JapeMain obj = new JapeMain(keyWords,userName,nodeName);
String grammarFileName = obj.createMainFile();
//String grammarFileName = "Main_c9059f64_6ddf_4188_a853_402737a7c1ef.jape";
//String grammarFileName = "Main_a.jape";
GateInstance.getInstance();
GateExtractor extObj = new GateExtractor( grammarFileName,keyWords,EnumMode.standalong);//0 for stand alone
//extObj.setKeywords(keyWords);

extObj.initSerialAnnie(0);

for(int i=0;i<testCount;i++){//for test reason
	// create a GATE corpus and add a document for each command-line
	// argument
	Corpus corpus = Factory.newCorpus("GateParser corpus");
	//corpus.clear();
	//-------create a file----------
	//createFile(corpus,null,null);//add file in corpus
	String uuid = CommonMethod.UuidGenerator();
	boolean flag = extObj.createCorpusDocument(corpus,null, resId,uuid) ;//dbType temp null
	// tell the pipeline about the corpus and run it
	if(flag){
		extObj.setCorpus(corpus);
		extObj.execute();
		//-------------analysis result--------
		String resultFile = extObj.processDoc(corpus,EnumProject.Carre,i);
	}
}//end of for
}*/
/*	public static void main3(String args[]) {

String keyWords = " heart failure , renal dysfunction constitutes, the cardiorenal syndrome";
String userName = "userName";
String nodeName = "nodeName";
String resId = "24886432";

JapeMain obj = new JapeMain(keyWords,"userName","nodeName");//(analysisKeywords,userName,nodeName);
String grammarFileName = obj.createMainFile();
EnumMode mode = EnumMode.standalong;
try {
	GateInstance.getInstance();
	//------read pattern file first
	CarreRule.getInstance();
	//------read property file next
	
	
	GateExtractor extObj = new GateExtractor( grammarFileName,keyWords,mode);//0 for stand alone

	extObj.initSerialAnnie(0);//0 stand alone,1 web
	Corpus corpus = Factory.newCorpus("GateParser corpus");
	//corpus.clear();
	//-------create a file----------
	String uuid = CommonMethod.UuidGenerator();
	//createFile(corpus,null,null);//add file in corpus
	boolean flag = extObj.createCorpusDocument(corpus,null, resId,uuid) ;//dbType temp null
	// tell the pipeline about the corpus and run it
	if(flag){
		extObj.setCorpus(corpus);
		extObj.execute();
		
		String rAbspath = extObj.processDoc(corpus,EnumProject.Carre,0);//0 useless
		
		CommonMethod.screenPrint("\n ...............rAbspath:"+rAbspath);				
	}
} catch (ResourceInstantiationException e) {
	// TODO Auto-generated catch block
	e.printStackTrace();
} catch (GateException e) {
	// TODO Auto-generated catch block
	e.printStackTrace();
}catch(Exception e){
	e.printStackTrace();
	CommonMethod.screenPrint("Exception from GateExtractor in main3:"+e.getMessage());
}

}
*/

/*
private  boolean tagAnnotation(SortedAnnotationList sortedAnnotations, StringBuffer editableContent, RepositioningInfo info)throws Exception
{
boolean rtn = false;

String startTagPart_1 = "<span GateID=\"";
String startTagPart_2 = "\" class=\"";
String endTag = "</span>";
long offset=0;
StringBuffer offsetStringBuffer = null;
String tmpId;
int annotSize = sortedAnnotations.size();
long buffIndx[][] = new long[annotSize][2];
buffIndx[0][0]=-1;
buffIndx[0][1]=-1;
int tmpCount = 0;
boolean findNest = false;
long tmpEndIndx,tmpOffset=0;


Annotation currAnnot;
long previousStart=-1;
long previousEnd=-1;

long insertPositionEnd;
long insertPositionStart;
StringBuffer editableContentCopy = new StringBuffer(editableContent);

SentenceRelationAnalysis drA ;
drA = new SentenceRelationAnalysis();
//loop annotations		loop from end to start, start offset big first
for (int i = annotSize - 1; i >= 0; --i) {//Loop annotation
	
	currAnnot = (Annotation) sortedAnnotations.get(i);
    //--------------------deal with this annot
	
	insertPositionStart = currAnnot.getStartNode().getOffset().longValue();
	insertPositionStart = info.getOriginalPos(insertPositionStart);
	
	insertPositionEnd = currAnnot.getEndNode().getOffset().longValue();
	insertPositionEnd = info.getOriginalPos(insertPositionEnd, true);
	
	offsetStringBuffer=new StringBuffer();
	//annotation found
	if (insertPositionEnd != -1 && insertPositionStart != -1) {
		
		
		buffIndx[tmpCount][0]=-1;//endIndex
		buffIndx[tmpCount][1]=-1;//tag offset
		
		
		//-----process tag
		String anntype = currAnnot.getType();
		String content = editableContentCopy.substring((int)insertPositionStart,(int)insertPositionEnd);
		//------------------------------------process known and unknown knowledge-----------
		CommonMethod.screenPrint("in GateExtractor before collectTag>>>>>>>>>> insertPositionStart="+insertPositionStart+",insertPositionEnd="+insertPositionEnd+",content="+content);
		
		drA.collectTags(anntype,(int)insertPositionStart,(int)insertPositionEnd,content);
		//---------------------------------------------------------------------
		String backGroundStr;
		backGroundStr = RandomColour.getRandomBackground(getTagColour(anntype));
		tmpId = currAnnot.getId().toString();
		
		
		if(previousEnd>-1 && previousEnd<insertPositionEnd){//nest
			findNest = true;
			for(int j=tmpCount-1;j>0;j--){
				tmpEndIndx = buffIndx[j][0];//endIndex
				if(tmpEndIndx>-1 && tmpEndIndx < insertPositionEnd){//not end
					
				}else{//find position
					for(int k=tmpCount-1;k>j;k--){
						tmpOffset += buffIndx[k][1];//tag offset
					}
					break;
				}
			}
			insertPositionEnd = insertPositionEnd+tmpOffset;//calculate offset
			//-------------insert nest tag here
			editableContent.insert((int) insertPositionEnd, endTag);//insert endTag
			editableContent.insert((int) insertPositionStart,backGroundStr);
			editableContent.insert((int) insertPositionStart, currAnnot.getType());
			editableContent.insert((int) insertPositionStart, startTagPart_2);
			editableContent.insert((int) insertPositionStart, tmpId);
			editableContent.insert((int) insertPositionStart, startTagPart_1);
			//-------------insert finished
			tmpCount = 0;
			tmpOffset = 0;
			
			findNest = false;

		}else{

			editableContent.insert((int) insertPositionEnd, endTag);//insert endTag
			offsetStringBuffer.append(endTag);
			

			//------------//insert startTag
			editableContent.insert((int) insertPositionStart,backGroundStr);
			offsetStringBuffer.append(backGroundStr);
			
			editableContent.insert((int) insertPositionStart, currAnnot.getType());
			offsetStringBuffer.append(currAnnot.getType());
			editableContent.insert((int) insertPositionStart, startTagPart_2);
			offsetStringBuffer.append(startTagPart_2);
			
			editableContent.insert((int) insertPositionStart, tmpId);
			offsetStringBuffer.append(tmpId);
			editableContent.insert((int) insertPositionStart, startTagPart_1);
			offsetStringBuffer.append(startTagPart_1);
			offset =offsetStringBuffer.toString().length();
			//summary[0]++;
			//CommonMethod.screenPrint("-->>weih add tag for tag:"+anntype+"------------------"+summary[0]+":>");
			previousStart = insertPositionStart;
			previousEnd = insertPositionEnd;
			
			buffIndx[tmpCount][0]=insertPositionEnd;//endIndex
			buffIndx[tmpCount][1]=offset;//tag offset
			tmpCount++;
		}
	}//end of if
}////Loop annotation

drA.prepareAnalysis();

return rtn;
}
*/	
//@todo
/*private  boolean tagAnnotation(SortedAnnotationList sortedAnnotations, StringBuffer editableContent, RepositioningInfo info){
	boolean rtn = false;
	String startTagPart_1 = "<span GateID=\"";
	String startTagPart_2 = "\" class=\"";
	String endTag = "</span>";
	long offset=0;
	String offsetString="";
	String tmpId;
	
	//loop annotations		loop from end to start
	for (int i = sortedAnnotations.size() - 1; i >= 0; --i) {

		Annotation currAnnot;
		long previousStart=-1;
		long previousEnd=-1;
		
		long insertPositionEnd;
		long insertPositionStart;
		currAnnot = (Annotation) sortedAnnotations.get(i);
	
		
		insertPositionStart = currAnnot.getStartNode().getOffset().longValue();
		insertPositionStart = info.getOriginalPos(insertPositionStart);
		
		insertPositionEnd = currAnnot.getEndNode().getOffset().longValue();
		insertPositionEnd = info.getOriginalPos(insertPositionEnd, true);
		
		//annotation found
		if (insertPositionEnd != -1 && insertPositionStart != -1) {
			//String anno = editableContent.substring((int) insertPositionStart,(int) insertPositionEnd);
			
			if(previousEnd>-1 && previousEnd<insertPositionEnd){//nest
				insertPositionEnd = insertPositionEnd+offset;
			}
			offsetString="";
			offset=0;
			
			editableContent.insert((int) insertPositionEnd, endTag);//insert endTag
			offsetString+=endTag;
			
			//-----process tag
			String anntype = currAnnot.getType();
			String backGroundStr;
			backGroundStr = RandomColour.getRandomBackground(getTagColour(anntype));
			//------------//insert startTag
			editableContent.insert((int) insertPositionStart,backGroundStr);
			offsetString+=backGroundStr;
			
			editableContent.insert((int) insertPositionStart, currAnnot.getType());
			offsetString+=currAnnot.getType();
			editableContent.insert((int) insertPositionStart, startTagPart_2);
			offsetString+=startTagPart_2;
			tmpId = currAnnot.getId().toString();
			editableContent.insert((int) insertPositionStart, tmpId);
			offsetString+=tmpId;
			editableContent.insert((int) insertPositionStart, startTagPart_1);
			offsetString+=startTagPart_1;
			offset =offsetString.length();
			//summary[0]++;
			//CommonMethod.screenPrint("-->>weih add tag for tag:"+anntype+"------------------"+summary[0]+":>");
			previousStart = insertPositionStart;
			previousEnd = insertPositionEnd;
			
		}//end of if
	}
	return rtn;
}*/




/*private HashSet getTagsForAnnotationSet(String keywords){
HashSet rtn = new HashSet(); //annotTypesRequired
//----------domainTags----------

String sProject = (String)CommonMethod.readProperties().getProperty("Project").trim();
String domainTagName = sProject + CommonMethod.DomainTagName;
String domainTagNames = (String)CommonMethod.readProperties().getProperty(domainTagName).trim();//, seperated
StringTokenizer st = new StringTokenizer(domainTagNames,",");
String tmpTag;
while(st.hasMoreTokens()){
	tmpTag = st.nextToken();
	rtn.add(tmpTag);
}
//----------keyword Tags--------
Vector keywordTags = JapeKeywords.getKeywordTagNames(keywords);
for(int i=0;i<keywordTags.size();i++){
	tmpTag = (String)keywordTags.get(i);
	rtn.add(tmpTag);
}
//------------------------------
return rtn; 

}*/

/*	
//return result file abs path
public String processDoc0(Corpus corpus,EnumProject project, int loop) throws IOException,Exception {
	this.project = project;
	// for each document, get an XML document with the
	// person and location names added
	String rtn = null;//return new generated result fileName
	Iterator docIter = corpus.iterator();
	int count = 0;
	String startTagPart_1 = "<span GateID=\"";
	String startTagPart_2 = "\" title=\"";
	String startTagPart_3 = "\" style=\"background:Red;\">";
	String endTag = "</span>";
	
	grpedColourTable = RandomColour.getGrpTagsWithColour(this.keywords,project);//generate colour table for further use
	//getRequiredTags
	HashSet annotTypesRequired = getTagsForAnnotationSet(); //include domainTags and keywordTags
	
	//loop files
	while(docIter.hasNext()) {
	    Document doc = (Document) docIter.next();
	    AnnotationSet defaultAnnotSet = doc.getAnnotations();
	    Set<Annotation> annos = new HashSet<Annotation>(defaultAnnotSet.get(annotTypesRequired));

	    FeatureMap features = doc.getFeatures();
	    String originalContent = (String)features.get(GateConstants.ORIGINAL_DOCUMENT_CONTENT_FEATURE_NAME);
	    RepositioningInfo info = (RepositioningInfo)features.get(GateConstants.DOCUMENT_REPOSITIONING_INFO_FEATURE_NAME);
	
	    ++count;
	    
	   // Out.prln("File name: '"+file.getAbsolutePath()+"'");
	    
	    if(originalContent != null && info != null) {

	    	//Out.prln("OrigContent and reposInfo existing. Generate file...");	
	    	Iterator annosIt = annos.iterator();
	    	Annotation currAnnot;
	    	SortedAnnotationList sortedAnnotations = new SortedAnnotationList(info);
	    	int testCount = 0;
	    	long tmpAnnotStart,tmpAnnotEnd;
	    	while(annosIt.hasNext()) {
	    		currAnnot = (Annotation) annosIt.next();
	    		//---------test---------
			     //tmpAnnotStart = currAnnot.getStartNode().getOffset().longValue();
			     // tmpAnnotStart = info.getOriginalPos(tmpAnnotStart);
			      
			      //tmpAnnotEnd = currAnnot.getEndNode().getOffset().longValue();
			      //tmpAnnotEnd = info.getOriginalPos(tmpAnnotEnd, true);

			     // String tmpContent = originalContent.substring((int)tmpAnnotStart,(int)tmpAnnotEnd);
		       // CommonMethod.screenPrint("in SortedAnnotationList:__________***_________start:"+tmpAnnotStart+",end:"+tmpAnnotEnd+",content:"+tmpContent);
		        //----------test---------------
	    		testCount++;
	    		sortedAnnotations.addSortedExclusive(currAnnot);
	    	} // while
	    	CommonMethod.screenPrint("testCount:"+testCount);
	    	StringBuffer editableContent = new StringBuffer(originalContent);
	    	
	    	//add tags in the content and extract knowledge from special tags
	    	boolean tagFlag =  tagAnnotation(sortedAnnotations,editableContent,info);
	    	
	    	
	    	boolean tagNameFlag = nameTags(editableContent);//add checkbox in the result
	    	String resultURL = "";
	    	//String resultFilePath = CommonMethod.readProperties().getProperty(CommonMethod.ResultFilePath).trim();
	    	try {
				String sUrl = doc.getParameterValue("sourceUrl").toString();//to Get tmp Name, URL of the file in DB
				CommonMethod.screenPrint("sUrl:"+sUrl);
				String docId = getDocIDByUrl(sUrl);//DBURL
				
				boolean flag =GenerateResultFile.generateResultTemplateFileDB0(editableContent,docId);
				if(flag){
					resultURL = this.getResultFileURL(docId);
				}
				
			    CommonMethod.screenPrint("in GateExtract processDoc after file write DB in processDoc: "+resultURL);
			    rtn = resultURL;
			    
			} catch (ResourceInstantiationException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

	    } // if - should generate
	    else if (originalContent != null) {
	     // Out.prln("OrigContent existing. Generate file...");
	    	File file = new File("./filesCreated/tag2_" + loop + ".html");
	      Iterator it = annos.iterator();
	      Annotation currAnnot;
	      SortedAnnotationList sortedAnnotations = new SortedAnnotationList(info);
	
	      while(it.hasNext()) {
	        currAnnot = (Annotation) it.next();
	        //CommonMethod.screenPrint(currAnnot.to);

	        sortedAnnotations.addSortedExclusive(currAnnot);//remove duplicated tag
	      } // while
	
	      StringBuffer editableContent = new StringBuffer(originalContent);
	      //boolean tagFlag =  tagAnnotation(sortedAnnotations,editableContent,info);
	      long insertPositionEnd;
	      long insertPositionStart;
	      // insert anotation tags backward
	      //Out.prln("Unsorted annotations count: "+annos.size());
	      //Out.prln("Sorted annotations count: "+sortedAnnotations.size());
	      for(int i=sortedAnnotations.size()-1; i>=0; --i) {
	        currAnnot = (Annotation) sortedAnnotations.get(i);
	        insertPositionStart =
	          currAnnot.getStartNode().getOffset().longValue();
	        insertPositionEnd = currAnnot.getEndNode().getOffset().longValue();
	        if(insertPositionEnd != -1 && insertPositionStart != -1) {
	          editableContent.insert((int)insertPositionEnd, endTag);
	          editableContent.insert((int)insertPositionStart, startTagPart_3);
	          editableContent.insert((int)insertPositionStart, currAnnot.getType());
	          editableContent.insert((int)insertPositionStart, startTagPart_2);
	          editableContent.insert((int)insertPositionStart,currAnnot.getId().toString());
	          editableContent.insert((int)insertPositionStart, startTagPart_1);
	        } // if
	      } // for
			
	      FileWriter writer = new FileWriter(file);
	      writer.write(editableContent.toString());
	      writer.close();
	      
	    }//else if
	    else {
	     // Out.prln("Content : "+originalContent);
	      //Out.prln("Repositioning: "+info);
	    }//else
	

	} // while for each doc
	return rtn;
}

*/	

	
	// Run from the command-line, with a list of URLs as argument.
	// <P><B>NOTE:</B><BR>
	// This code will run with all the documents in memory - if you
	// want to unload each from memory after use, add code to store
	// the corpus in a DataStore.

/*		public static void main1(String args[]) throws GateException, IOException {
		 
		//------------------------	    
		  // initialise ANNIE (this may take several minutes)
		  //GateParser annie = new GateParser();
			GateExtractor annieInstance = GateExtractor.getInstance();
			annieInstance.initSerialAnnie();
			
			for(int i=0;i<testCount;i++){//for test reason
				// create a GATE corpus and add a document for each command-line
				// argument
				Corpus corpus = Factory.newCorpus("GateParser corpus");
				//corpus.clear();
				//-------create a file----------
				createFile(corpus);//add file in corpus
				// tell the pipeline about the corpus and run it
				annieInstance.setCorpus(corpus);
				annieInstance.execute();
				new GateExtractor().processDoc(corpus,i);
			}//end of for
		} // main
*/
	// Run from the command-line, with a list of URLs as argument.
	// <P><B>NOTE:</B><BR>
	// This code will run with all the documents in memory - if you
	// want to unload each from memory after use, add code to store
	// the corpus in a DataStore.

	/*	public static void main0(String args[]) throws GateException, IOException {
		  // initialise the GATE library
		  Out.prln("Initialising GATE...");
		  Gate.init();
		  Out.prln("...GATE initialised");
		  
			File gateHome = Gate.getGateHome();
			File pluginsHome = new File(gateHome, "plugins");
			Out.prln(pluginsHome.getAbsolutePath());
		//-------------gate register
		  
			Gate.getCreoleRegister().registerDirectories(
					new File(pluginsHome, "ANNIE").toURL());
			Gate.getCreoleRegister().registerDirectories(
					new File(pluginsHome, "Gazetteer_Ontology_Based").toURL());
			Gate.getCreoleRegister().registerDirectories(
					new File(pluginsHome, "Ontology").toURL());
			Gate.getCreoleRegister().registerDirectories(
					new File(pluginsHome, "Tools").toURL());
		  
		//------------------------	    
		  // initialise ANNIE (this may take several minutes)
		  //GateParser annie = new GateParser();
			GateExtractor annieInstance = GateExtractor.getInstance();
			//annie.initAnnie();
			annieInstance.initSerialAnnie();
			// create a GATE corpus and add a document for each command-line
			// argument
			Corpus corpus = Factory.newCorpus("GateParser corpus");
			
			createFile(corpus);
		
			// tell the pipeline about the corpus and run it
			annieInstance.setCorpus(corpus);
			annieInstance.execute();
		
			new GateExtractor().processDoc(corpus,1);
		} // main

	*/	




//
// Extracting article title from the full publication reference.
// ACM style: BARNES, C., SHECHTMAN, E., FINKELSTEIN, A., AND GOLDMAN, D. B. 2009. Patchmatch: a randomized correspondence algorithm for structural image editing.
// Number style: 1. van de Panne M. From footprints to animation.
// @param reference
// @return
//
/*	private String getTitleACM(String reference){
	String title = "";
	if (reference.endsWith(".")){
		reference = reference.substring(0, reference.length()-1); //remove "."
	}
	title = reference.substring(reference.lastIndexOf(".") + 2);
	return title;
}

//
// Insert HTML tags around the annotated items.
// @param references
// @param sortedAnnotations
// @param editableContent
// @param info
// @return
//
private Extraction tagAnnotation(Set<String> references, SortedAnnotationList sortedAnnotations, StringBuffer editableContent, RepositioningInfo info){
	List<Citation> citations = new ArrayList<Citation>();
	List<String> allEntities = new ArrayList<String>();
	List<String> sentences = new ArrayList<String>();

	for (int i = sortedAnnotations.size() - 1; i >= 0; --i) {
		Annotation currAnnot;
		long insertPositionEnd;
		long insertPositionStart;
		currAnnot = (Annotation) sortedAnnotations.get(i);
		insertPositionStart = currAnnot.getStartNode()
				.getOffset().longValue();
		insertPositionStart = info
				.getOriginalPos(insertPositionStart);
		insertPositionEnd = currAnnot.getEndNode().getOffset()
				.longValue();
		insertPositionEnd = info.getOriginalPos(
				insertPositionEnd, true);
		//annotation found
		if (insertPositionEnd != -1
				&& insertPositionStart != -1) {
			String anno = editableContent.substring(
					(int) insertPositionStart,
					(int) insertPositionEnd);
			anno = anno.replace("\n", " ").replace("\r", " "); //remove line breaks
			anno = anno.replace("&#8727;", "*");
			String link = "";
			//ACM style: match references with in text citations
			if (currAnnot.getFeatures().get("rule") == "citationACM"){
				//Out.prln("~~~~~ annotation for citation: " + anno);
				String surname = anno.substring(0, anno.indexOf(" "));
				//Out.prln("~~~~~ surname " + surname);
				String year = anno.substring(anno.lastIndexOf(" ") + 1);
				if (year.contains("]")){
					year = year.substring(0, year.length()-1);
					//Out.prln("~~~~~ year " + year);
				}
				Iterator<String> iterref = references.iterator();
				while (iterref.hasNext()){
					String ref = iterref.next();
					ref = ref.replace("-", ""); 
					ref = ref.replace(":", "");
					ref = ref.replace("\n", "").replace("\r", "");
					//System.out.println("??????????????Ref: " + ref);
					//System.out.println("-------------------------------");
					//match found
					if (ref.contains(surname.toUpperCase()) && ref.contains(year)){					
						citations = buildCitations(citations, anno, ref, year, link, 1);	
						//System.out.println("?????????????Citation found in ACM: " + anno);
						//citations.add(citation);
					}
				}
				//Out.prln("+++++citation found");
			} else if (currAnnot.getFeatures().get("rule") == "citationEG"){
				Iterator<String> iterref = references.iterator();
				while (iterref.hasNext()){
					String ref = iterref.next();
					ref = ref.replace("-", ""); 
					ref = ref.replace(":", "");
					ref = ref.replace("\n", "").replace("\r", "");
					//System.out.println("reference: " + ref);
					//System.out.println("cited: " + anno);
					//match found
					if (ref.contains(anno)){
						System.out.println("********** Citation matched.");
						citations = buildCitations(citations, anno, ref, "", link, 2);		
						//citations.add(citation);
					}
				}
			} else if (currAnnot.getFeatures().get("rule") == "citationNum"){
				Iterator<String> iterref = references.iterator();
				while (iterref.hasNext()){
					String ref = iterref.next();
					ref = ref.replace("-", ""); 
					ref = ref.replace(":", "");
					ref = ref.replace("\n", "").replace("\r", "");
					ref = ref.replace("</p><p>", " ");
					int refNum = 0;
					try{
						refNum = Integer.parseInt(ref.substring(0, ref.indexOf(".")));
					} catch (NumberFormatException e){
						refNum = 0;
					}
					
					//System.out.println("reference: " + ref);
					//System.out.println("reference number: " + refNum);
					//System.out.println("cited: " + anno);
					int citeNum = 0;
					//annotations like [24-28]
					if (anno.contains("&#8211;")){
						citeNum = Integer.parseInt(anno.substring(1, anno.indexOf("&")));
					} else {
						citeNum = Integer.parseInt(anno.substring(1, anno.indexOf("]")));
					}			
					
					//match found
					if (refNum == citeNum){					
						citations = buildCitations(citations, anno, ref, "", link, 3);		
						//citations.add(citation);
					}
				}
			}
			
			System.out.println("-->>weih before tag did not buildcitations------------------");
			//Out.prln("+++++" + anno);
			
			editableContent.insert((int) insertPositionEnd, endTag);
			String anntype = currAnnot.getType();
			if (anntype == "Lookup") {
				// weih editableContent.insert(
				//		(int) insertPositionStart,
				//		startTagPart_3);	
				//allEntities.add(anno.toLowerCase()); 
				// commoned by xia if (!entities.contains(anno.toLowerCase())){
				//	entities.add(anno.toLowerCase());
				//}					
			} else if (anntype == "KeySentence"){
				// weih editableContent.insert(
				//		(int) insertPositionStart,
				//		startTagPart_4);
				//sentences.add(anno);
			} else if (anntype == "Citation"){
				// weih editableContent.insert((int) insertPositionStart,startTaga_2);
				//editableContent.insert((int) insertPositionStart,link);
				//editableContent.insert((int) insertPositionStart,startTaga_1);
				//editableContent.insert((int) insertPositionStart,startTagPart_5);
				
			} else if (anntype == "BibliographicEntry"){
				// weih editableContent.insert((int) insertPositionStart,startTagPart_6);
			}else if (anntype == "cardiorenalTag"){//"-->>weih add tag /cardiorenalTag/
				editableContent.insert((int) insertPositionStart,startTagPart_wh_1);
				summary[0]++;
				System.out.println("-->>weih add tag for cardiorenalTag------------------"+summary[0]+":>");
			}else if (anntype == "cardiorenalComorbiditiesTag"){//"-->>weih add tag /cardiorenalComorbiditiesTag/
				editableContent.insert((int) insertPositionStart,startTagPart_wh_2);
				summary[1]++;
				System.out.println("-->>weih add tag for cardiorenalComorbiditiesTag------------------"+summary[1]+":>");
			}else if (anntype == "cardiorenalRiskFactorsTag"){//"-->>weih add tag /cardiorenalRiskFactorsTag/
				editableContent.insert((int) insertPositionStart,startTagPart_wh_3);
				summary[2]++;
				System.out.println("-->>weih add tag for cardiorenalRiskFactorsTag------------------"+summary[2]+":>");
			}else if (anntype == "heartFailureWorseningRenalFunctionTag"){//"-->>weih add tag /cardiorenalRiskFactorsTag/
				editableContent.insert((int) insertPositionStart,startTagPart_wh_4);
				summary[3]++;
				System.out.println("-->>weih add tag for heartFailureWorseningRenalFunctionTag------------------"+summary[3]+":>");
			}
			
			// heartFailureWorseningRenalFunctionTag
			//	cardiorenalTag
			//		cardiorenalRiskFactorsTag
			//			cardiorenalComorbiditiesTag
			//
			System.out.println("-->>weih add tag finished------------------");

			editableContent.insert((int) insertPositionStart,
					currAnnot.getType());
			editableContent.insert((int) insertPositionStart,
					startTagPart_2);
			editableContent.insert((int) insertPositionStart,
					currAnnot.getId().toString());
			editableContent.insert((int) insertPositionStart,
					startTagPart_1);
					
		} // if
	}
	ListManager lm = new ListManager();
	
	Extraction extraction = new Extraction();
	extraction.setCitations(citations);
	//extraction.setEntities(entities);
	extraction.setSentences(sentences);
	extraction.setEntityMap(lm.getItemFrequency(allEntities));

	return extraction;	
	
}	

//
// Search citations and build citation with available info.
// @param citations
// @param anno
// @param ref
// @param year
// @param title
// @param author
// @param link
// @param refType: 1 ACM; 2 EuroGraphic; 3 Number
//
private List<Citation> buildCitations(List<Citation> citationList, String anno, String ref, String year, String link, int refType){
	List<Citation> citations = citationList;
	
	//search article from Google API
	FromGoogle search = new FromGoogle();
	try {
		switch (refType) {
		case 1:
			System.out.println("??????? Type 1: ACM");
			link = search.searchDoc(getTitleACM(ref),googleSearchKey);
			break;
		case 2:
			link = search.searchDoc(getTitleEG(ref), googleSearchKey);
			break;
		case 3:
			link = search.searchDoc(getTitleNum(ref), googleSearchKey);
			break;
		default:
			break;
		}				
	} catch (IOException e) {
		System.out.println("Exception: google search");
		logger.info("mylogs: Exception: google search");
		throw new Exception(e.getMessage(), "Back", "dashboard");
	}
	
	//link = "test link";
	String noDot = ref.substring(0, ref.lastIndexOf(".") - 1);
	String title = noDot.substring(noDot.lastIndexOf(".") + 1);
	
	String authoryear = ref.substring(0, ref.lastIndexOf(".") - 1).substring(0, noDot.lastIndexOf("."));
	
	String author = authoryear.substring(0, authoryear.length() - 5);
	
	//Remove repeated papers in the citation display list.
	int l = citations.size();
	System.out.println("??????????????start length: " + l);
	if (l == 0){
		Citation citation = new Citation();
		citation.setCite(anno);
		citation.setReference(ref);
		citation.setYear(year);
		citation.setTitle(title);
		citation.setAuthor(author);
		citation.setSource(link);
		//return citation;
		citations.add(citation);
	}else{
		for (Citation c : citations){
			if (c != null){
				System.out.println("stored title: " + c.getTitle());
				System.out.println("new  title: " + title);
				if (!c.getTitle().equals(title)){
					l--;
				}
				System.out.println("current length: " + l);
				if (l == 0){
					Citation citation = new Citation();
					citation.setCite(anno);
					citation.setReference(ref);
					citation.setYear(year);
					citation.setTitle(title);
					citation.setAuthor(author);
					citation.setSource(link);
					citations.add(citation);
					
					break;
				}
			}				
		}				
	}	
	return citations;
}
//
// Obtaining all references in an article.
// @param sortedAnnotations
// @param editableContent
// @param info
// @return
//
private Set<String> extractReference(SortedAnnotationList sortedAnnotations, StringBuffer editableContent, RepositioningInfo info){
	Set<String> rtn = new HashSet<String>();
	long refSectionPosition = 0;
	//first get the position of the reference section
	for (int i = sortedAnnotations.size() - 1; i >= 0; --i) {
		Annotation currAnnot;
		long insertPositionEnd;
		long insertPositionStart;
		currAnnot = (Annotation) sortedAnnotations.get(i);
		insertPositionStart = currAnnot.getStartNode()
				.getOffset().longValue();
		insertPositionStart = info
				.getOriginalPos(insertPositionStart);
		insertPositionEnd = currAnnot.getEndNode().getOffset()
				.longValue();
		insertPositionEnd = info.getOriginalPos(
				insertPositionEnd, true);
		if (insertPositionEnd != -1
				&& insertPositionStart != -1) {
			String anno = editableContent.substring(
					(int) insertPositionStart,
					(int) insertPositionEnd);
			if (currAnnot.getFeatures().get("rule") == "refSection"){
				refSectionPosition = insertPositionEnd;
				break;
			}
			//Out.prln("+++++" + anno);
		} // if
	} // for
	//only consider the annotations after the reference section.
	for (int i = sortedAnnotations.size() - 1; i >= 0; --i) {
		Annotation currAnnot;
		long insertPositionEnd;
		long insertPositionStart;
		currAnnot = (Annotation) sortedAnnotations.get(i);
		insertPositionStart = currAnnot.getStartNode()
				.getOffset().longValue();
		insertPositionStart = info
				.getOriginalPos(insertPositionStart);
		insertPositionEnd = currAnnot.getEndNode().getOffset()
				.longValue();
		insertPositionEnd = info.getOriginalPos(
				insertPositionEnd, true);
		if (insertPositionEnd > refSectionPosition
				&& insertPositionStart != -1) {
			String anno = editableContent.substring(
					(int) insertPositionStart,
					(int) insertPositionEnd);
			if (currAnnot.getFeatures().get("kind") == "reference"){
				if (anno.contains("&#8727;")){
					//System.out.println("&*************&&& got unicode");
					anno = anno.replace("&#8727;", "*");
				}				
				//Out.prln("+++++citation found: " + anno);
				rtn.add(anno);
			}
			//Out.prln("+++++" + anno);
		} // if
	} // for
	//System.out.println("Total reference number: " + references.size());
	return rtn;
}	
	public static void main1(String args[]) throws GateException, IOException {
		GateExtractor annieInstance = GateExtractor.getInstance();
		Corpus corpus = Factory.newCorpus("GateParser corpus");
		  
		URL u = new URL("http://10.1.62.218:8080/heartFailure.txt");
		FeatureMap params = Factory.newFeatureMap();
		params.put("sourceUrl", u);
		params.put("preserveOriginalContent", new Boolean(true));
		params.put("collectRepositioningInfo", new Boolean(true));
		Out.prln("Creating doc for " + u);
		Document tmpDoc = (Document)Factory.createResource("gate.corpora.DocumentImpl", params);
		corpus.add(tmpDoc);
	
		// tell the pipeline about the corpus and run it
		annieInstance.setCorpus(corpus);
		annieInstance.execute();
	
		// for each document, get an XML document with the
		// person and location names added
		Iterator docIter = corpus.iterator();
		int count = 0;
		String startTagPart_1 = "<span GateID=\"";
		String startTagPart_2 = "\" title=\"";
		String startTagPart_3 = "\" style=\"background:Red;\">";
		String startTagPart_4 = "\" style=\"background:Green;\">";
		String startTagPart_5 = "\" style=\"background:Yellow;\">";
		String startTagPart_6 = "\" style=\"background:Blue;\">";
		String startTagPart_wh_1 = "\" style=\"background:Orange;\">";//orange
		String startTagPart_wh_2 = "\" style=\"background:#E3E4FA;\">";//lavender light blue
		String startTagPart_wh_3 = "\" style=\"background:#87F717;\">";//lawngreen
		String startTagPart_wh_4 = "\" style=\"background:#C57726;\">";//peru brown		
		
		String endTag = "</span>";
	  //loop files
		while(docIter.hasNext()) {
		    Document doc = (Document) docIter.next();
		    AnnotationSet defaultAnnotSet = doc.getAnnotations();
		    Set annotTypesRequired = new HashSet();
		    annotTypesRequired.add("Person");
		    annotTypesRequired.add("Location");
		    //------------
		    annotTypesRequired.add("Lookup");
		    annotTypesRequired.add("KeySentence");
		    annotTypesRequired.add("Citation");
		    annotTypesRequired.add("BibliographicEntry");
		    annotTypesRequired.add("RefSection");
		    annotTypesRequired.add("cardiorenalTag");
		    annotTypesRequired.add("cardiorenalComorbiditiesTag");
		    annotTypesRequired.add("cardiorenalRiskFactorsTag");
		    annotTypesRequired.add("heartFailureWorseningRenalFunctionTag");	
		    
		    Set<Annotation> annos = new HashSet<Annotation>(defaultAnnotSet.get(annotTypesRequired));
		
		    FeatureMap features = doc.getFeatures();
		    
		    String originalContent = (String)features.get(GateConstants.ORIGINAL_DOCUMENT_CONTENT_FEATURE_NAME);
		    RepositioningInfo info = (RepositioningInfo)features.get(GateConstants.DOCUMENT_REPOSITIONING_INFO_FEATURE_NAME);
		
		    ++count;
		    File file = new File("StANNIE_" + count + ".HTML");
		    Out.prln("File name: '"+file.getAbsolutePath()+"'");
		    
		    if(originalContent != null && info != null) {
		    	
		    	Out.prln("OrigContent and reposInfo existing. Generate file...");	
		    	Iterator annosIt = annos.iterator();
		    	Annotation currAnnot;
		    	SortedAnnotationList sortedAnnotations = new SortedAnnotationList();
		
		    	while(annosIt.hasNext()) {
		    		currAnnot = (Annotation) annosIt.next();
		    		sortedAnnotations.addSortedExclusive(currAnnot);
		    	} // while
		
		    	StringBuffer editableContent = new StringBuffer(originalContent);
		    	
		    	Set<String> references = annieInstance.extractReference(sortedAnnotations, editableContent, info);
				extraction = tagAnnotation(references, sortedAnnotations, editableContent, info);
				
				//cdc.updateExtract(doc.getName().substring(0, doc.getName().lastIndexOf(".")) + ".pdf", extraction);
				String id = doc.getName().substring(0, doc.getName().lastIndexOf("."));
				cdc.updateExtract(id, extraction);
				


				FileWriter writer = new FileWriter(file);
				writer.write(editableContent.toString());
				writer.close();


		    } // if - should generate
		    
		
		    String xmlDocument = doc.toXml(annos, false);
		    String fileName = new String("StANNIE_toXML_" + count + ".HTML");
		    FileWriter writer = new FileWriter(fileName);
		    writer.write(xmlDocument);
		    writer.close();
		} // while for each doc
	}
	

	
	// The Corpus Pipeline application to contain ANNIE 
	private SerialAnalyserController annieSerialController;

	
	String startTagPart_1 = "<span GateID=\"";
	String startTagPart_2 = "\" title=\"";
	String startTagPart_3 = "\" style=\"background:Red;\">";
	String startTagPart_4 = "\" style=\"background:Green;\">";
	String startTagPart_5 = "\" style=\"background:Yellow;\">";
	String startTagPart_6 = "\" style=\"background:Blue;\">";
	String startTagPart_wh_1 = "\" style=\"background:Orange;\">";//orange
	String startTagPart_wh_2 = "\" style=\"background:#E3E4FA;\">";//lavender light blue
	String startTagPart_wh_3 = "\" style=\"background:#87F717;\">";//lawngreen
	String startTagPart_wh_4 = "\" style=\"background:#C57726;\">";//peru brown
	String startTaga_1 = "<a href=\"";
	String startTaga_2 = "\" target=\"_blank\">";
	int[] summary = {0,0,0,0};
	//String startTaga_2 = "\">";
	String endTag = "</a></span>";
	



{tags
		    //annotTypesRequired.add("Person");
		    //annotTypesRequired.add("Location");
		    //------------
		    //annotTypesRequired.add("Lookup");
		    //annotTypesRequired.add("KeySentence");
		    //annotTypesRequired.add("Citation");
		    //annotTypesRequired.add("BibliographicEntry");
		    //annotTypesRequired.add("RefSection");
		    //annotTypesRequired.add("cardiorenalTag");
		    //annotTypesRequired.add("cardiorenalComorbiditiesTag");
		    //annotTypesRequired.add("cardiorenalRiskFactorsTag");
		    //annotTypesRequired.add("heartFailureWorseningRenalFunctionTag");	
		    //---------------
		    //annotTypesRequired.add("CarreRisk");	
		    
		    
		    //annotTypesRequired.add("heartFailureTag");
		    //annotTypesRequired.add("the_heartTag1");
		    //annotTypesRequired.add("the_cardiorenal_syndromeTag1");
		    //annotTypesRequired.add("heart_failureTag");

}


*
*/	


