package org.ccgv.text.gate;

import gate.util.GateException;
import gate.*;

import gate.creole.*;
import gate.util.*;

//import org.ccgv.text.gate.GateParser.SortedAnnotationList;
import org.ccgv.text.gate.util.*;
import gate.util.persistence.PersistenceManager;
import gate.corpora.RepositioningInfo;
import java.io.File;
import java.io.IOException;

public class GateInstance {
	
	///private String pluginsHome;
	private static GateInstance instance = null;
	
	private GateInstance(){
		
		//pluginsHome = "D:"+File.separator+"tools"+File.separator+"Gate"+File.separator+"gate-7.0-build4195-BIN"+File.separator+"plugins";
		//pluginsHome = "D:"+File.separator+"tools"+File.separator+"Gate"+File.separator+"gate-8.0-build4825-ALL"+File.separator+"plugins";
		//System.setProperty("gate.plugins.home",pluginsHome);
		init();
	}
	public static GateInstance getInstance() throws GateException, IOException{
		if(instance==null){
			instance = new GateInstance();
		}
		return instance;
	}
	
	private void init(){
		try {
			// $mavenHome /.m2/repository/uk/ac/gate/gateCore
			Gate.setGateHome(new File(CommonMethod.getMavenHome()+".m2"+File.separator+"repository"+File.separator+"uk"+File.separator+"ac"+File.separator+"gate"+File.separator+"gate-core"));
			File gateHome = Gate.getGateHome();
			CommonMethod.screenPrint("in Gate before init GateInstance:"+gateHome.getPath());
			
			Gate.init();
			File pluginsHome = new File(gateHome, "plugins");
			//-------------gate register
			Gate.getCreoleRegister().registerDirectories(new File(pluginsHome, "ANNIE").toURL());
			Gate.getCreoleRegister().registerDirectories(new File(pluginsHome, "Gazetteer_Ontology_Based").toURL());
			Gate.getCreoleRegister().registerDirectories(new File(pluginsHome, "Ontology").toURL());
			Gate.getCreoleRegister().registerDirectories(new File(pluginsHome, "Tools").toURL());
			Gate.getCreoleRegister().registerDirectories(new File(pluginsHome, "Ontology_Tools").toURL());
			
			
		} catch (GateException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch(IOException e){
			e.printStackTrace();
		}
	}
}
