package org.ccgv.text.gate.jape;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Calendar;
import java.util.StringTokenizer;
import java.util.Vector;

import org.ccgv.text.gate.GateExtractor.EnumProject;
import org.ccgv.text.gate.util.CommonMethod;


public class JapeMain {
	//this class is used to create a main.jape
	//MultiPhase: AcademicDocument

	//add phases by the order of pipeline
	//Phases:
	//NumberNormaliser
	//KeySentence
	//Citation
	//extractKeyWords
	String keyWords=null,userName,nodeName;
	String japePath;
	Vector tagNames;
	
	public JapeMain(String keyWords, String userName, String nodeName){		
		if(keyWords!=null && !keyWords.trim().equals("")){
			this.keyWords = keyWords;
		}
		this.userName = userName;
		this.nodeName = nodeName;

	}//constructor
	public String createMainFile(){
		String rtn = "";
		japePath = CommonMethod.getJapePathWrite();
		
		try {
			 
			String content = "This is the content to write into file";
			String uuid = CommonMethod.UuidGenerator();
			String fileName = uuid+".jape";//tmpFile
			String fileNamePath = japePath+fileName;
			CommonMethod.screenPrint("in JapeMain createMainFile:"+fileNamePath);
			
			File tmpFile = new File(fileNamePath);
 
			FileWriter fw = new FileWriter(tmpFile.getAbsoluteFile());
			BufferedWriter bw = new BufferedWriter(fw);
			StringBuffer sb = getJapeForMain();
			
			bw.write(sb.toString());
			bw.close();
			String tmpMainFileName = uuid;//JapeMain.format2MainJape(uuid);
			CommonMethod.screenPrint("file:"+tmpMainFileName);
			//Thread.sleep(3000);
			
			String orgFileName = japePath+tmpMainFileName+".jape";
			File orgFile = new File(orgFileName);
			
			String formatMainJape = format2MainJape(tmpMainFileName);//"Main_"+uuid+".jape"
			String newMainFileName = japePath+formatMainJape;
			
			File newMainFile = new File(newMainFileName);
			CommonMethod.screenPrint("Before rename Main ,org:"+orgFileName+",new:"+newMainFileName);
			
			boolean flag = false;
			int count = 0;
			while(!flag){
				count++;
				flag = orgFile.renameTo(newMainFile);//check if main file write finished
				CommonMethod.screenPrint("rename flag:"+flag+" count:"+count);
				if(flag){// main file write finished
					long size = newMainFile.length();
					CommonMethod.screenPrint("main file size:"+size);
					if(size>0){
							rtn = formatMainJape;//uuid;
					}
				}
			}
/*			File mainFile = new File(japePath+mainFileName+".jape");
			boolean finishFlag = tmpFile.renameTo(mainFile);//used to detact if file is finished
			CommonMethod.screenPrint("is file can be renamed:"+fileNamePath+" renamed to : "+mainFileName+" success:"+finishFlag);
			CommonMethod.screenPrint("file:"+fileName+" created under:"+japePath);*/
			
			CommonMethod.screenPrint("in JapeMain last step reach rtn="+rtn);
		} catch (IOException e) {
			e.printStackTrace();
		}catch(Exception e){
			e.printStackTrace();
		}
		return rtn;
	}
	//write content
	private StringBuffer getJapeForMain(){
		StringBuffer rtn = new StringBuffer();
		String phaseName = createMultiPhaseName();
		if(this.keyWords!=null){
		
			//----------create keywords Jape---------
			JapeKeywords obj = new JapeKeywords(this.keyWords,this.userName,this.nodeName);
			String keywordsFileName = obj.createKeywordsFile();//return only uuid
			this.tagNames = obj.getKeywordsTagNames();
			String japePath = CommonMethod.getJapePathWrite();
			
			String orgFileName = japePath+keywordsFileName+".jape";
			String formatKwordsJape = JapeKeywords.format2KwordsJape(keywordsFileName);
			String newKwordsFileName = japePath+formatKwordsJape;
			
			File orgFile = new File(orgFileName);
			File newKwordsFile = new File(newKwordsFileName);
			CommonMethod.screenPrint("Before rename ,org:"+orgFileName+",new:"+newKwordsFileName);
			//while(orgFile.renameTo(newKwordsFile)){//used to detact if file is finished
			//while(!newKwordsFile.exists()){//used to detact if file is finished
			//boolean flag = orgFile.renameTo(newKwordsFile);
			boolean flag = false;
			int count = 0;
			while(!flag){
				count++;
				flag = orgFile.renameTo(newKwordsFile);//check if keywords file write finished
				//CommonMethod.screenPrint("rename flag:"+flag+" count:"+count);
				if(flag){//write main file
					if(this.userName!=null && !this.userName.equals("")){
						String japeName = new StringTokenizer(formatKwordsJape,".").nextToken();
						//CommonMethod.screenPrint("japeName:"+japeName);
						//add phases by the order of pipeline
						rtn.append("MultiPhase:").append(phaseName).append("\n");
						rtn.append("Phases:").append("\n");
						rtn.append(japeName).append("\n");//Keywords jape
						rtn.append("Numbermatch").append("\n");//Keywords jape
						//rtn.append("NumberNormaliser").append("\n");//number jape
						/*Vector vJapes = getOntologyAndDomainJape();
						for(int i=0;i<vJapes.size();i++){
							rtn.append((String)vJapes.get(i)).append("\n");//number jape
						}*/
	
						
						//------test
						/*for(int i=0;i<9000000;i++){
							rtn.append(CommonMethod.ChicProject).append("ssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssssss\n");
						}*/
						//---------test finished
					}
				}
			}//end of while
			CommonMethod.screenPrint("flag:"+flag);
		}//end of if
		else{
			rtn.append("MultiPhase:").append(phaseName).append("\n");
			rtn.append("Phases:").append("\n");
			rtn.append("Numbermatch").append("\n");//Keywords jape
		}
		
		return rtn;
	}
	public static Vector getOntologyAndDomainJape(){
		Vector rtn = new Vector();
		String project = CommonMethod.getProject();//Domain Dic
		EnumProject theProject = EnumProject.valueOf(project);
		
		StringTokenizer st ; 
		String tmpJapes= "",tmpTag="";
		
		 switch (theProject) {
		    case Carre: 
		    	tmpJapes = CommonMethod.getCarreOntology()+","+CommonMethod.getCarreDomain();
		      break;   
		    case Chic: // fall through to C
		    	tmpJapes = CommonMethod.getChicOntology()+","+CommonMethod.getChicDomain();
		    	break;
		    case Div: 
		    	tmpJapes = "";
		      break;
		  }
		 if(tmpJapes !=null && !tmpJapes.equals("")){
			 st = new StringTokenizer(tmpJapes,",");
			 while(st.hasMoreTokens()){
					tmpTag = st.nextToken();
					rtn.add(tmpTag);
				}
		 }
		 return rtn;
		
	}
	public static String format2MainJape(String uuid){
		return "Main_"+uuid+".jape";
	}
	private String createMultiPhaseName(){
		String rtn = "";
		Calendar cal = Calendar.getInstance();
		long timeLong = cal.getTimeInMillis();
		rtn = "Multi"+"_"+this.userName+"_"+this.nodeName+"_"+timeLong;
		return rtn;
		
	}
	
	public Vector getKeywordsTagNames(){
		return this.tagNames;
	}
	
	public static void testRename(){
		String japePath = CommonMethod.getJapePathWrite();
		String oldName = japePath+" c6db5ff0_7e8e_47f4_a5e7_b3a1ffb0691e.jape";
		String newName = japePath+"abv_c6db5ff0_7e8e_47f4_a5e7_b3a1ffb0691e.jape";
		CommonMethod.screenPrint("oldName:"+oldName);
		CommonMethod.screenPrint("newName:"+newName);
		
		File oldFile = new File(oldName);
		File newFile = new File(newName);
		if(oldFile.exists()){
			boolean flag = oldFile.renameTo(newFile);
			//CommonMethod.screenPrint("rename Flag:"+flag);
		}else{
			CommonMethod.screenPrint("does not exist");
		}
	}
	public static void testCreateFile(){
		String keyWords = " heart failure , renal dysfunction constitutes, the cardiorenal syndrome";
		String userName = "userName";
		String nodeName = "nodeName";
		JapeMain obj = new JapeMain(keyWords,userName,nodeName);
		String tmpMainFileName = obj.createMainFile();//return uuid
		CommonMethod.screenPrint("file:"+tmpMainFileName);
		
		/*String japePath = CommonMethod.getJapePathWrite();
		
		String orgFileName = japePath+tmpMainFileName+".jape";
		File orgFile = new File(orgFileName);
		
		String formatMainJape = JapeMain.format2MainJape(tmpMainFileName);//"Main_"+uuid+".jape"
		String newMainFileName = japePath+formatMainJape;
		
		File newMainFile = new File(newMainFileName);
		CommonMethod.screenPrint("Before rename Main ,org:"+orgFileName+",new:"+newMainFileName);

		boolean flag = false;
		int count = 0;
		while(!flag){
			count++;
			flag = orgFile.renameTo(newMainFile);//check if main file write finished
			CommonMethod.screenPrint("rename flag:"+flag+" count:"+count);
			if(flag){// main file write finished
				
			}
		}*/
	}
	public static void main(String[] args) {
		//testRename();
		testCreateFile();
		//----------
	}//main
}
