package org.ccgv.text.gate.util;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

import org.apache.commons.codec.binary.Base64;
import org.ccgv.text.gate.GateExtractor.FileNameEnum;
import org.ccgv.text.resource.api.PubmedDataInterface;
import org.ccgv.text.util.DBAccess;
import org.lightcouch.Attachment;

public class GenerateResultFile {
	//----------from /gateCfg/resultTemplate.html---
	//read template then create a new File with content.
	public GenerateResultFile(String uuid){

	}
	public static boolean generateResultTemplateFileDB0(StringBuffer sbContent, String docId)throws IOException{
		boolean rtn = false;
		//get Template File
		String tplFilePath = CommonMethod.getGateCfgPathWrite();
		String tplFilePathName = tplFilePath+"resultTemplate.html";
		
		StringBuffer sbTemplate = new StringBuffer();
		BufferedReader in = null;
		try 
		{
				in = new BufferedReader(new FileReader(tplFilePathName));
				String line = null;
				while ((line = in.readLine()) != null) {
					sbTemplate.append(line + '\n');
				}
		} 
		finally 
		{
			if (in != null) {
				in.close();
			}
		}
		String marker = "<body>";
		int startindex = sbTemplate.indexOf(marker);
		sbTemplate.insert(startindex+marker.length(), sbContent.toString());
		
		//write in DB
		byte[] bytes = sbTemplate.toString().getBytes();
		String data = Base64.encodeBase64String(bytes);
		Attachment attachment = new Attachment(data, "text/plain");
		
		
		DBAccess dbA = new DBAccess();
		rtn = dbA.updateAcademyAttachment(docId, attachment, FileNameEnum.ResultFile.toString()+".html");
		
		return rtn;
		
	}
	//no need template file
	public static boolean generateResultFileDB(StringBuffer sbContent, String docId)throws IOException{
		boolean rtn = false;

		
		//write in DB
		byte[] bytes = sbContent.toString().getBytes();
		String data = Base64.encodeBase64String(bytes);
		Attachment attachment = new Attachment(data, "text/html");
		
		DBAccess dbA = new DBAccess();
		rtn = dbA.updateAcademyTrainingPaperAttachment(docId, attachment, FileNameEnum.ResultFile.toString()+".html");
		return rtn;
		
	}
	//result file uuid
	public static boolean generateResultTemplatedFile(StringBuffer sbContent,String resultFilePath) throws IOException{
		boolean rtn = false;
		
		String tplFilePath = CommonMethod.getGateCfgPathWrite();
		String tplFilePathName = tplFilePath+"resultTemplate.html";
		
		StringBuffer sbTemplate = new StringBuffer();
		BufferedReader in = null;
		try 
		{
				in = new BufferedReader(new FileReader(tplFilePathName));
				String line = null;
				while ((line = in.readLine()) != null) {
					sbTemplate.append(line + '\n');
				}
		} 
		finally 
		{
			if (in != null) {
				in.close();
			}
		}
		String marker = "<body>";
		int startindex = sbTemplate.indexOf(marker);
		sbTemplate.insert(startindex+marker.length(), sbContent.toString());
		
		FileWriter f = new FileWriter(new File(resultFilePath));
		f.write(sbTemplate.toString());
		f.flush();
		f.close();
		rtn = true;

		return rtn;
	}
	public static boolean createShowFileFromResult(String uuid) throws IOException{
		boolean rtn = false;
		
		String tplFilePath = CommonMethod.getGateCfgPathWrite();
		String tplFilePathName = tplFilePath+"resultTemplate.html";
		String showFilePath = CommonMethod.getResultFilePath();
		String showFilePathName = showFilePath+"show_"+uuid+".html";
		
		StringBuffer sb = new StringBuffer();
		BufferedReader in = null;
		try 
		{
				in = new BufferedReader(new FileReader(tplFilePathName));
				String line = null;
				while ((line = in.readLine()) != null) {
					sb.append(line + '\n');
				}
		} 
		finally 
		{
			if (in != null) {
				in.close();
			}
		}
		String marker = "<body>";
		int startindex = sb.indexOf(marker);
		sb.insert(startindex+marker.length(), "abcdefg");
		
		FileWriter f = new FileWriter(new File(showFilePathName));
		f.write(sb.toString());
		f.flush();
		f.close();
		rtn = true;

		return rtn;
	}
	public static void main(String args[]) throws IOException{
		GenerateResultFile.createShowFileFromResult("testDomainOnto");
	}
}
