package org.ccgv.text.servlets;

	import org.ccgv.text.gate.GateExtractor;
import org.ccgv.text.gate.GateExtractor.EnumMode;
import org.ccgv.text.gate.GateExtractor.EnumProject;
import org.ccgv.text.gate.GateInstance;
import org.ccgv.text.gate.PipelineFactory;
import org.ccgv.text.gate.jape.JapeKeywords;
import org.ccgv.text.gate.jape.JapeMain;
import org.ccgv.text.gate.pattern.CarreRule;
import org.ccgv.text.gate.pattern.HotmapRule;
import org.ccgv.text.gate.util.CommonMethod;
import org.ccgv.text.model.Citation;
import org.ccgv.text.resource.api.DataInterfaceImpl;
import org.ccgv.text.resource.api.PubmedDataInterface;
import org.ccgv.text.vac.BatchProcess;
import org.ccgv.text.vac.BatchProcess.ResTypeEnum;

	import gate.Corpus;
import gate.Factory;
import gate.util.GateException;
import gate.creole.ResourceInstantiationException;

	import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;

	import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import java.net.URL;




import com.fasterxml.jackson.databind.ObjectMapper;

	public class BatchProcessingServlet extends HttpServlet{
		private String resId;//paperId in pubmed
		private String searchKeywords;
		private String dics;
		private String strProject;
		private String dbType;
		
	    public void doGet(HttpServletRequest request, HttpServletResponse response)
	    throws IOException, ServletException
	    {
	    	searchKeywords = (String)request.getParameter("keyWords").trim();//search Key Words
	    	dbType = (String)request.getParameter("dbType").trim();
	    	ResTypeEnum resType = ResTypeEnum.valueOf(dbType);//pubmed("0"),ieee("1")
	    	response.setContentType("text/html");
	        PrintWriter output = response.getWriter();
	        //CommonMethod.screenPrint("parameters from keywords window page, :"+searchKeywords);
	       try{
				CommonMethod.screenPrint("-------------------batch for searchKeyWords:"+searchKeywords+",in resType:"+resType);
	
				BatchProcess bProcess = new BatchProcess(searchKeywords,resType);
				bProcess.doProcess();
				String convertedKeyWords = DataInterfaceImpl.convertKeyWords(searchKeywords,resType);
				bProcess.batchUploadExcels(convertedKeyWords,resType);//convertedKeyWords used to set batchKey //one docId:"b0372bad_454f_4571_aa34_aea1a3847abf"
				CommonMethod.screenPrint("------------------batch for converted keyWords:"+convertedKeyWords+",over");
			}  catch(Exception e){
				e.printStackTrace();
				CommonMethod.screenPrint("Exception from GateExtractor in main4:"+e.getMessage());
			}

	    }


	}
	
