package org.ccgv.text.servlets;

import gate.Corpus;
import gate.Factory;
import gate.creole.ResourceInstantiationException;
import gate.util.GateException;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.URL;
import java.util.ArrayList;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.ccgv.text.gate.GateExtractor;
import org.ccgv.text.gate.GateInstance;
import org.ccgv.text.gate.PipelineFactory;
import org.ccgv.text.gate.GateExtractor.EnumMode;
import org.ccgv.text.gate.GateExtractor.EnumProject;
import org.ccgv.text.gate.jape.JapeMain;
import org.ccgv.text.gate.pattern.CarreRule;
import org.ccgv.text.gate.pattern.HotmapRule;
import org.ccgv.text.gate.util.CommonMethod;
import org.ccgv.text.model.NewPair;
import org.ccgv.text.vac.AnalysisDomainVAC;
import org.ccgv.text.vac.BatchProcess;
import org.ccgv.text.vac.BatchProcess.ResTypeEnum;

public class GateAnalysisVAC extends HttpServlet{
	private String resId;//paperId in pubmed
	private String analysisKeywords;
	private String dics;
	private String strProject;
	private String dbType;
	private boolean debugMode = false;
	
    public void doGet(HttpServletRequest request, HttpServletResponse response)
    throws IOException, ServletException
    {
    	resId = (String)request.getParameter("resId").trim();
    	analysisKeywords = (String)request.getParameter("analysisKeywords").trim();
    	dbType = (String)request.getParameter("dbType").trim();
    	dics = (String)request.getParameter("dics").trim();
    	strProject = (String)request.getParameter("project").trim();
    	EnumProject project = EnumProject.valueOf(strProject);
    	
    	
    	response.setContentType("text/html");
        PrintWriter output = response.getWriter();
        
        CommonMethod.screenPrint("parameters from keywords window page, resId:"+resId+",analysisKeywords:"+analysisKeywords);
       try{
   			
   			ResTypeEnum resType = ResTypeEnum.valueOf(dbType);
   			CommonMethod.screenPrint("resType:"+resType);
   			
   			AnalysisDomainVAC anlsVac = new AnalysisDomainVAC(resId,resType);
   			anlsVac.setKeyWords(analysisKeywords);
   			anlsVac.setRunMode(EnumMode.web);
   			String resultFileURL  = anlsVac.doAnalysis();
   			CommonMethod.screenPrint("result from AnalysisDomainVAC:"+resultFileURL);
   			
   	
   		} catch(Exception e){
			e.printStackTrace();
			CommonMethod.screenPrint("Exception from GateExtractor in main4:"+e.getMessage());
		}
    }
    
    //temp function when test
	private static boolean clearAllData(boolean debugMode) {
		boolean rtn = true;
		BatchProcess bProcess = new BatchProcess();
		if(!debugMode){
			bProcess.removeAllDocModel();
			bProcess.removeAllSentenceModel();
			bProcess.removeAllPhraseModel();
			bProcess.removeAllSentenceByView("paper/batchSentenceCarre");
			bProcess.removeAllByView("paper/batchTagPair");
		}
		return rtn;
	}
    //temp function when test
	private static boolean clearDomainData(boolean debugMode) {
		boolean rtn = true;
		BatchProcess bProcess = new BatchProcess();
		if(!debugMode){
			bProcess.removeAllSentenceByView("paper/batchSentenceCarre");
			bProcess.removeAllByView("paper/batchTagPair");
		}
		return rtn;
	}
}
