package org.ccgv.text.servlets;
import org.ccgv.text.gate.util.CommonMethod;

import java.io.*;
import java.util.*;

import javax.servlet.*;
import javax.servlet.http.*;

import org.ccgv.text.resource.api.PubmedDataInterface;
import org.ccgv.text.model.Citation;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;

public class SearchInterface extends HttpServlet{
	private String dbType;
	private String keyWords;
	
    public void doGet(HttpServletRequest request, HttpServletResponse response)
    throws IOException, ServletException
    {
        dbType = (String)request.getParameter("dbType");
        keyWords = (String)request.getParameter("keyWords");
    	response.setContentType("text/html");
        PrintWriter out = response.getWriter();
        
		PubmedDataInterface pubmed = new PubmedDataInterface();
		ArrayList<Citation> citationList = null;
		String searchResult = "";
		try {
			citationList = pubmed.processSearch(keyWords);
			ObjectMapper mapper = new ObjectMapper();
			searchResult =  mapper.writeValueAsString(citationList);
		} catch (Exception e) {
			// TODO: handle exception
		}
        //String searchResult = formatData();
        out.println(searchResult);
    }
	
    
    
    
    
    
    
    
    
    
    private String formatData() throws JsonProcessingException {
		String rtn = "";
		ObjectMapper mapper = new ObjectMapper();
        
        List<Citation> citationList = new ArrayList<Citation>();
        for(int i=0;i<5;i++){
        	Citation aPaper = new Citation();
        	aPaper.setTitle("title"+i);
        	aPaper.setAuthor("author"+i);
        	aPaper.setResId("abcdId"+i);
        	aPaper.setYear("200"+i);
        	aPaper.setSource("Science"+i);
        	citationList.add(aPaper);
        }
         rtn= mapper.writeValueAsString(citationList);
        CommonMethod.screenPrint("in SearchInterface jsonString:"+rtn);
        return rtn;
	}
    public static void main(String args[]){
    	SearchInterface obj = new SearchInterface();
    	try {
			obj.formatData();
		} catch (JsonProcessingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    }
	
}
