package org.ccgv.text.util;

import org.ccgv.text.gate.util.CommonMethod;





import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;

import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellStyle;
import org.apache.poi.ss.usermodel.CreationHelper;
import org.apache.poi.ss.usermodel.Font;
import org.apache.poi.ss.usermodel.Hyperlink;
import org.apache.poi.ss.usermodel.IndexedColors;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.ss.util.WorkbookUtil;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

public class ExcelReadWrite {
	String resultExcelPath;
	String resultExcelFile;
	
	public ExcelReadWrite(String Id){
		resultExcelPath = CommonMethod.getResultFilePath();
		resultExcelFile+= Id+".xls";
		
	}
	public boolean createExcel(){
		return false;
	}

	public static void main(String args[]){
		
		main3();
	}
	

	public static void main3(){
		
	    Workbook wb = new XSSFWorkbook(); //or new HSSFWorkbook();
	    CreationHelper createHelper = wb.getCreationHelper();

	    //cell style for hyperlinks
	    //by default hyperlinks are blue and underlined
	    CellStyle hlink_style = wb.createCellStyle();
	    Font hlink_font = wb.createFont();
	    hlink_font.setUnderline(Font.U_SINGLE);
	    hlink_font.setColor(IndexedColors.BLUE.getIndex());
	    hlink_style.setFont(hlink_font);

	    Cell cell;
	    Sheet sheet = wb.createSheet("Hyperlinks");
	    //URL
	    cell = sheet.createRow(0).createCell((short)0);
	    cell.setCellValue("URL Link");

	    Hyperlink link = createHelper.createHyperlink(Hyperlink.LINK_URL);
	    link.setAddress("http://poi.apache.org/");
	    cell.setHyperlink(link);
	    cell.setCellStyle(hlink_style);

	    //link to a file in the current directory
	    cell = sheet.createRow(1).createCell((short)0);
	    cell.setCellValue("File Link");
	    link = createHelper.createHyperlink(Hyperlink.LINK_FILE);
	    link.setAddress("link1.xls");
	    cell.setHyperlink(link);
	    cell.setCellStyle(hlink_style);

	    //e-mail link
	    cell = sheet.createRow(2).createCell((short)0);
	    cell.setCellValue("Email Link");
	    link = createHelper.createHyperlink(Hyperlink.LINK_EMAIL);
	    //note, if subject contains white spaces, make sure they are url-encoded
	    link.setAddress("mailto:poi@apache.org?subject=Hyperlinks");
	    cell.setHyperlink(link);
	    cell.setCellStyle(hlink_style);

	    //link to a place in this workbook

	    //create a target sheet and cell
	    Sheet sheet2 = wb.createSheet("Target Sheet");
	    sheet2.createRow(0).createCell((short)0).setCellValue("Target Cell");

	    cell = sheet.createRow(3).createCell((short)0);
	    cell.setCellValue("Worksheet Link");
	    Hyperlink link2 = createHelper.createHyperlink(Hyperlink.LINK_DOCUMENT);
	    link2.setAddress("'Target Sheet'!A1");
	    cell.setHyperlink(link2);
	    cell.setCellStyle(hlink_style);

	    try {
			FileOutputStream out = new FileOutputStream("D:\\work\\test\\hyperinks.xlsx");
			wb.write(out);
			out.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	public static void main2(){
		 	try {
				Workbook wb = new HSSFWorkbook();
				//Workbook wb = new XSSFWorkbook();
				CreationHelper createHelper = wb.getCreationHelper();
				Sheet sheet = wb.createSheet("new sheet");

				// Create a row and put some cells in it. Rows are 0 based.
				Row row = sheet.createRow((short)0);
				// Create a cell and put a value in it.
				Cell cell = row.createCell(0);
				cell.setCellValue(1);

				// Or do it on one line.
				row.createCell(1).setCellValue(1.2);
				row.createCell(2).setCellValue(
				     createHelper.createRichTextString("This is a string"));
				row.createCell(3).setCellValue(true);

				// Write the output to a file
				FileOutputStream fileOut = new FileOutputStream("D:\\work\\test\\workbook.xls");
				wb.write(fileOut);
				fileOut.close();
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
	}
	
	public static void main1(){
		
		try {
			Workbook wb = new HSSFWorkbook();  // or new XSSFWorkbook();
			Sheet sheet1 = wb.createSheet("new sheet");
			Sheet sheet2 = wb.createSheet("second sheet");

			// Note that sheet name is Excel must not exceed 31 characters
			// and must not contain any of the any of the following characters:
			// 0x0000
			// 0x0003
			// colon (:)
			// backslash (\)
			// asterisk (*)
			// question mark (?)
			// forward slash (/)
			// opening square bracket ([)
			// closing square bracket (])

			// You can use org.apache.poi.ss.util.WorkbookUtil#createSafeSheetName(String nameProposal)}
			// for a safe way to create valid names, this utility replaces invalid characters with a space (' ')
			String safeName = WorkbookUtil.createSafeSheetName("[O'Brien's sales*?]"); // returns " O'Brien's sales   "
			Sheet sheet3 = wb.createSheet(safeName);

			FileOutputStream fileOut = new FileOutputStream("D:\\work\\test\\workbook3.xls");
			wb.write(fileOut);
			fileOut.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private static void main0() {
		try {
			Workbook wb = new HSSFWorkbook();
			FileOutputStream fileOut = new FileOutputStream("D:\\work\\test\\workbook.xls");
			wb.write(fileOut);
			fileOut.close();

			Workbook wb2 = new XSSFWorkbook();
			FileOutputStream fileOut1 = new FileOutputStream("D:\\work\\test\\workbook2.xlsx");
			wb2.write(fileOut1);
			fileOut1.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
