package org.ccgv.text.util;

import org.ccgv.text.gate.util.CommonMethod;

import java.awt.List;
import java.io.File;
import java.util.ArrayList;

/**
the first one will list all the files and folder names under a directory
the second one will list all the file names under a directory
the third one will list all the folder names under a directory
the fourth one will list all the files from the directory and its sub-directories (be carefull with this one!)
 */
public class FileLister {
 
    /**
     * List all the files and folders from a directory
     * @param directoryName to be listed
     */
    public void listFilesAndFolders(String directoryName){
 
        File directory = new File(directoryName);
 
        //get all the files from a directory
        File[] fList = directory.listFiles();
 
        for (File file : fList){
            System.out.println(file.getName());
        }
    }
 
    /**
     * List all the files under a directory
     * @param directoryName to be listed
     */
    public ArrayList listFiles(String directoryName){
    	ArrayList rtn = new ArrayList();
        File directory = new File(directoryName);
 
        //get all the files from a directory
        File[] fList = directory.listFiles();
 
        for (File file : fList){
            if (file.isFile()){
            	rtn.add(file.getName());
            	
            }
        }
        return rtn;
    }
 
    /**
     * List all the folder under a directory
     * @param directoryName to be listed
     */
    public ArrayList listFolders(String directoryName){
 
    	ArrayList rtn = new ArrayList();
        File directory = new File(directoryName);
 
        //get all the files from a directory
        File[] fList = directory.listFiles();
        for (File file : fList){
            if (file.isDirectory()){
            	//CommonMethod.screenPrint(file.getName());
            	rtn.add(file.getName());
            }
        }
        return rtn;
    }
 
    /**
     * List all files from a directory and its subdirectories
     * @param directoryName to be listed
     */
    public void listFilesAndFilesSubDirectories(String directoryName){
 
        File directory = new File(directoryName);
 
        //get all the files from a directory
        File[] fList = directory.listFiles();
 
        for (File file : fList){
            if (file.isFile()){
                System.out.println(file.getAbsolutePath());
            } else if (file.isDirectory()){
                listFilesAndFilesSubDirectories(file.getAbsolutePath());
            }
        }
    }
 
    public static void main (String[] args){
 
    	FileLister listFilesUtil = new FileLister();
 
        final String directoryLinuxMac ="/Users/loiane/test";
 
        //Windows directory example
        final String directoryWindows ="C://test";
        //"D://work//webWork//apache-tomcat-8.0.0-RC5//webapps//InfoMining//trainingFiles//cloth"
        final String directoryWin1 = "D://work//webWork//apache-tomcat-8.0.0-RC5//webapps//InfoMining//trainingFiles//cloth";
        final String directoryWin2 = "D://work//webWork//apache-tomcat-8.0.0-RC5//webapps//InfoMining//trainingFiles//";
 
        listFilesUtil.listFiles(directoryWin1);
        ArrayList folders = listFilesUtil.listFolders(directoryWin2);
    }
}
