package org.ccgv.text.vac;



import gate.Annotation;
import gate.AnnotationSet;
import gate.Corpus;
import gate.Document;
import gate.Factory;
import gate.FeatureMap;
import gate.GateConstants;
import gate.corpora.RepositioningInfo;
import gate.creole.ResourceInstantiationException;
import gate.util.GateException;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.net.MalformedURLException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Collections;
import java.util.Date;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.apache.commons.codec.binary.Base64;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.ccgv.text.clearnlp.ClearnlpDecode;
import org.ccgv.text.clearnlp.SentenceRelationAnalysis;
import org.ccgv.text.clearnlp.SentenceRelationModel;
import org.ccgv.text.clearnlp.SentenceWordModel;
import org.ccgv.text.gate.ComparatorPhrase;
import org.ccgv.text.gate.GateExtractor;
import org.ccgv.text.gate.GateInstance;
import org.ccgv.text.gate.PipelineFactory;
import org.ccgv.text.gate.GateExtractor.EnumMode;
import org.ccgv.text.gate.GateExtractor.EnumProject;
import org.ccgv.text.gate.GateExtractor.SortedAnnotationList;
import org.ccgv.text.gate.pattern.ArgsModel;
import org.ccgv.text.gate.pattern.ArgslistModel;
import org.ccgv.text.gate.pattern.CarreRule;
import org.ccgv.text.gate.pattern.HotmapRule;
import org.ccgv.text.gate.pattern.RuleBaseWh;
import org.ccgv.text.gate.util.CommonMethod;
import org.ccgv.text.model.Citation;
import org.ccgv.text.model.TrainingExcelModel;
import org.ccgv.text.model.TrainingModel;
import org.ccgv.text.model.db.TagModel;
import org.ccgv.text.model.db.TrainingPaperModel;
import org.ccgv.text.model.db.TrainingPhraseModel;
import org.ccgv.text.model.db.TrainingSentenceModel;
import org.ccgv.text.resource.api.PubmedDataInterface;
import org.ccgv.text.util.CouchDBClientImpl;
import org.ccgv.text.util.DBAccess;
import org.lightcouch.Attachment;
import org.lightcouch.CouchDbClient;
import org.lightcouch.Response;
import org.lightcouch.View;

import com.google.gson.JsonArray;
import com.google.gson.JsonObject;

public class FolderProcess {//for db-test4
	private String keyWords;
	private String db;
	private boolean debugMode = false;
	public enum statusEnum{init,normal};
	

	public static void main(String args[]){
		
		String keyWords = "wilms tumor wt1 dds";
		FolderProcess bProcess = new FolderProcess(keyWords,"pubmed");
		try {
/*			bProcess.test();*/
			//bProcess.doProcess();
			
			SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.S");
	        CommonMethod.screenPrint("before process: " + dateFormat.format(Calendar.getInstance().getTime()));
			bProcess.batchUploadExcels();//one docId:"b0372bad_454f_4571_aa34_aea1a3847abf"
			CommonMethod.screenPrint("after processs: " + dateFormat.format(Calendar.getInstance().getTime()));
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		CommonMethod.screenPrint("main over");
	}
	public FolderProcess(String keyWords, String db){
		//this.keyWords = "wt1 wilms tumor dds";
		this.keyWords = keyWords;
		this.db = db;
	}
	public String getDB(){
		return this.db;
	}
	
	
	
	public void doProcess(){
		SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.S");
        CommonMethod.screenPrint("before process: " + dateFormat.format(Calendar.getInstance().getTime()));
        
        
		statusEnum runFlag = statusEnum.init;
		ArrayList<String> ids;

		//-------do this once--------------
		if(runFlag == statusEnum.init){//insert document
			ids = preProcessDoc();
			CommonMethod.screenPrint(ids.toString());
		}else{
			//--------for test------
			String idStr = "c36162a0_65e8_44fa_a850_58ea602aa954, ffd1d848_8029_49d9_9695_df1afd2045e2, 3e2fe5c4_2d46_49b4_9488_b2318e4bdd22, 8a686b9f_726b_45f8_9baa_6fcfc2647a1b, e47dd7fc_ab4e_4cb4_8073_fa505fc692ea, 6e3bed03_2d29_446f_a0e9_d9a909d3bb7b, 67a7c66e_2acb_4ad0_bc24_bb131f4f85a4, 01388b90_096f_4d56_929c_fecec6cdd1fe, 2ef80cd5_a27d_4011_8fbb_045096e9b3fd, 15528701_9156_4b19_917b_630b5d37dca6, 278c22fa_b68b_4dbf_964a_03d30b9746b8, 6bc55c51_2414_43c1_bc94_9b2a90521f76, 77036cde_19ab_4517_ae29_7feb15429c05, f4e095f5_9a0f_4399_9d6a_8eeebdaf459d, d237fee8_ba93_478f_8e95_33f13e0de7ca, a079c88b_99c0_4eea_bd63_1d18d75626c6, 48ed0f6a_b31b_4c86_8c99_23be6ac4e80c, 6f2cbf58_ca5c_4bd8_8de0_13e0de4f96c3, 245ee9a0_79f3_4f67_90a1_a00565bc7513, 47880da7_33e4_473f_bb43_c83972b33df8";
		    String[] idArr =idStr.split(",");  	    
		    ids = new ArrayList();
		    for(String aId:idArr){
		    	ids.add(aId);
		    }
		}
		//-----------------------------------
		boolean flag = doWith(ids);
		CommonMethod.screenPrint("flag:"+flag);
		CommonMethod.screenPrint("after processs: " + dateFormat.format(Calendar.getInstance().getTime()));
	}
	
	
	private boolean doWith(ArrayList<String> idList){
		boolean rtn = false;
		String dics;
		dics = "Carre";
		//------------------------------------------
		EnumMode mode = EnumMode.standalong;
		CommonMethod.screenPrint("in GateExtractor step1 mode:"+mode);
		try{
			GateInstance.getInstance();
			CommonMethod.screenPrint("in GateExtractor step2 GateInstance");
		
			//------read property file next
			//----------GATE init PR ------------------------
			PipelineFactory.initProcessingResouces(mode);
			CommonMethod.screenPrint("in GateExtractor step3 initProcessingResouces");
			//----------------
			GateExtractor extObj = new GateExtractor( null,null,mode);//( grammar,keyWords,mode)0 for stand alone
			//extObj.setTestFile(testFile);
			extObj.initSerialAnnieNew(dics);//null, (dics);//AssembleProcessingResource
			
			CommonMethod.screenPrint("in GateExtractor step4 initSerialAnnieNew");
			Corpus corpus = Factory.newCorpus("GateParser corpus Batch");
			//corpus.clear();	
			//----------view of paper-:emit([doc.typeName,doc.title], fNames);------------------------
			
			if(createCorpusDocumentsFromDB(corpus,idList)){ //	/dbType temp null
					if( corpus.size() >0 ){
						
						extObj.setCorpus(corpus);
						SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.S");
				        CommonMethod.screenPrint("before: " + dateFormat.format(Calendar.getInstance().getTime()));
				        extObj.execute();
				        CommonMethod.screenPrint("after execute: " + dateFormat.format(Calendar.getInstance().getTime()));
						
						String rAbspath ;
						rAbspath= processDoc(corpus);//processDoc(corpus,project,0);//0 useless
						CommonMethod.screenPrint("\n ...............rAbspath:"+rAbspath);				
					}	
			}
		} catch (MalformedURLException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (ResourceInstantiationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (GateException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return rtn;
	}
	//process doc in gate
	public String processDoc(Corpus corpus) throws IOException,Exception {
		String rtn = null;//return new generated result fileName
		Iterator docIter = corpus.iterator();

		//grpedColourTable = RandomColour.getGrpTagsWithColour("",EnumProject.Carre);//generate colour table for further use
		//getRequiredTags
		HashSet annotTypesRequired = getTagsForAnnotationSet(); //include domainTags and keywordTags
		String strLink,docKey,portion,docId;
		while(docIter.hasNext()) {//loop doc files
		    Document doc = (Document) docIter.next();
		    strLink = doc.getParameterValue("sourceUrl").toString();
		    CommonMethod.screenPrint("strLink:"+strLink);
		    //get id and fileName from URL
		    docKey = getDocKeyFromUrl(strLink);//id-portion
		    String docKeyArr[] = docKey.split("-");//[0]id,[1]Abstract
		    TrainingExcelModel docModel = new TrainingExcelModel();
		    
		    docModel.setPaperPortion("Abstract");
		    docModel.setPid(docKeyArr[0]);
		    //-----------------------------
		    AnnotationSet defaultAnnotSet = doc.getAnnotations();
		    //--------------test tags from Gate---------------
		    /*Iterator annosTest = defaultAnnotSet.iterator();
		    Annotation testA;
		    while(annosTest.hasNext()) {
		    	testA = (Annotation) annosTest.next();
		    	CommonMethod.screenPrint("***********"+testA.getType()+","+testA.getFeatures().toString());
		    }*/
		    //-----------------test over---------
		    
		    Set<Annotation> annos = new HashSet<Annotation>(defaultAnnotSet.get(annotTypesRequired));
		    FeatureMap features = doc.getFeatures();
		    String originalContent = (String)features.get(GateConstants.ORIGINAL_DOCUMENT_CONTENT_FEATURE_NAME);
		    RepositioningInfo info = (RepositioningInfo)features.get(GateConstants.DOCUMENT_REPOSITIONING_INFO_FEATURE_NAME);
		
		   // Out.prln("File name: '"+file.getAbsolutePath()+"'");		    
		    if(originalContent != null && info != null) {

		    	//Out.prln("OrigContent and reposInfo existing. Generate file...");	
		    	Iterator annosIt = annos.iterator();
		    	Annotation currAnnot;
		    	SortedAnnotationList sortedAnnotations = new SortedAnnotationList(info);
		    	int testCount = 0;
		    	long tmpAnnotStart,tmpAnnotEnd;
		    	while(annosIt.hasNext()) {
		    		currAnnot = (Annotation) annosIt.next();
		    		sortedAnnotations.addSortedExclusive(currAnnot);
		    	} // while
		    	CommonMethod.screenPrint("testCount:"+testCount);
		    	StringBuffer editableContent = new StringBuffer(originalContent);
		    	
		    	//add tags in the content and extract knowledge from special tags
		    	//output sentenct
		    	boolean tagFlag =  tagAnnotation(sortedAnnotations,editableContent,info,docModel);//docModel:model:pId,url,folderName,title
		  
		    	String resultFilePath = CommonMethod.readProperties().getProperty(CommonMethod.ResultFilePath).trim();
		    	
		    } // if - should generate

		} // while for each doc
		

		return rtn;
	}

	////docModel:model:pId,url,folderName,title
	private boolean tagAnnotation(SortedAnnotationList sortedAnnotations,  StringBuffer editableContentCopy, RepositioningInfo info,TrainingExcelModel docModel){
		boolean rtn = true;
		
		int annotSize = sortedAnnotations.size();
		
		Annotation currAnnot;
		
		SentenceRelationAnalysis srA ;
		
		long insertPositionEnd;
		long insertPositionStart;
		String anntype,content;
		DBAccess aDB = new  DBAccess();
		//-------------------------------------------------------
		for (int i = annotSize - 1,j=0; i >= 0; --i,j++) {//Loop sentence annotation
			currAnnot = (Annotation) sortedAnnotations.get(i);
	        //--------------------deal with this annot
			insertPositionStart = currAnnot.getStartNode().getOffset().longValue();
			insertPositionStart = info.getOriginalPos(insertPositionStart);
			
			insertPositionEnd = currAnnot.getEndNode().getOffset().longValue();
			insertPositionEnd = info.getOriginalPos(insertPositionEnd, true);
		
			//annotation found
			if (insertPositionEnd != -1 && insertPositionStart != -1) {
				//-----process tag
				anntype = currAnnot.getType();//type
				content = editableContentCopy.substring((int)insertPositionStart,(int)insertPositionEnd);//content
				if(anntype.equals("Sentence")){
					TagModel tmpModel;
					//---------style class-------
					
					tmpModel = new TagModel();
					tmpModel.setContent(content);
					tmpModel.setStartId((int)insertPositionStart);
					tmpModel.setEndId((int)insertPositionEnd);	
					tmpModel.setTagName(anntype);
	
					//----------write db with sentence Info
					String  sentenceId = null;
					if(!debugMode){
						sentenceId = saveSentenceModel(docModel,tmpModel);//save one sentence
					}
					try {
						//DepRelParser drInstance = DepRelParser.getInstance();
						ClearnlpDecode cdInstance = ClearnlpDecode.getInstance();
						
						CommonMethod.screenPrint("in prepareAnalysis aStrongSentence:"+content);
						//--------DR process one sentence a time----------
						SentenceRelationModel aSentenceModel = cdInstance.process( content);// one sentence
						//-----------invoke eric's method to write Excel/DB
						analysisSentence(aSentenceModel,sentenceId);
						//----------------------------
						//---------------------------------------------------------------------
					} catch (  IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}else{}
				//write aSentenceModel into Excel
				
				//---------------list add finished
			}//end of if
		}//end of for annotation	
		return rtn;
	}
	
	private boolean analysisSentence(SentenceRelationModel aSentenceModel, String sentenceId){
		RuleBaseWh ruleInstance = null;
		String exeProject = EnumProject.Hotmap.toString();//CommonMethod.getProject();
		if(exeProject.equals(EnumProject.Carre.toString())){
			ruleInstance = CarreRule.getInstance();
		}else if(exeProject.equals(EnumProject.Hotmap.toString())){
			ruleInstance = HotmapRule.getInstance();
		}
		ruleInstance.Extraxtinf(aSentenceModel);
		
		boolean flag = savePhraseDoc(aSentenceModel,sentenceId);

		return flag;
	}
	public boolean savePaperModel(TrainingPaperModel tModel){
		boolean rtn = false;
		String resId ;
		if(tModel!=null){
			resId = tModel.getPId();
			
			
			try {
				PubmedDataInterface pubmed = new PubmedDataInterface();
				pubmed.setRetMax(100);
				String abstractStr = (pubmed.processFetchAbstract(resId)).toString(); //http://www.ncbi.nlm.nih.gov/pubmed/16817450
				if(abstractStr!=null && ! abstractStr.equals("")){
					DBAccess aDB = new  DBAccess();
					CouchDbClient dbClient = aDB.getDbClient();
					Response response = dbClient.save(tModel);
					//-------attchment
					tModel = dbClient.find(TrainingPaperModel.class, response.getId());
					StringBuffer abstractBuf = new StringBuffer();
					abstractBuf.append("<p>").append(abstractStr).append("</p>");
					//----attachment
					byte[] bytes = abstractBuf.toString().getBytes(); 
				    String data = Base64.encodeBase64String(bytes);
				    Attachment attachment = new Attachment(data,"text/html");//(data, "text/plain");	
				    //Bar bar = new Bar(); 
				    tModel.addAttachment("Abstract.html",attachment);
				    response = dbClient.update(tModel); //update
				    rtn = true;
				    //-----------
				}
				
				
				
			} catch (Exception e) {
				// TODO Auto-generated catch block
				CommonMethod.screenPrint("error:in BatchProcess getTrainingPaperModel:"+e.getMessage());
				e.printStackTrace();
			}//19008416
		}
		return rtn;

	}
	
	public String saveSentenceModel(TrainingExcelModel docModel, TagModel tagModel){
		String rtn = "";
		DBAccess dbA = new DBAccess();
		CouchDbClient dbClient  = dbA.getDbClient();
		
		String sentenceId =  CommonMethod.UuidGenerator();
		TrainingSentenceModel tsModel = new TrainingSentenceModel(sentenceId,"batch_sentence");//id,docType
		tsModel.setPid(docModel.getPid());//paperModelId
		tsModel.setPapPortion(docModel.getPaperPortion());
		tsModel.setStartId(tagModel.getStartId());//sentence index
		tsModel.setEndId(tagModel.getEndId());
		tsModel.setSenContent(tagModel.getContent());
		tsModel.setTagName(tagModel.getTagName());
		//----------------save-----------
		Response response = dbClient.save(tsModel); //save
		tsModel = dbClient.find(TrainingSentenceModel.class,  response.getId());
		rtn = sentenceId;
		return rtn;
	}
	private boolean savePhraseDoc(SentenceRelationModel aSentenceModel,String sentenceId){
		boolean flag = false;
		
		ArrayList<ArgslistModel> argsListModels;
		ArrayList<ArgsModel> argsModels;
		DBAccess dbA = new DBAccess();
		ArrayList<TrainingPhraseModel> tmpList = new ArrayList<TrainingPhraseModel>();		
		TrainingSentenceModel aSentence = readSentenceById(sentenceId);
		String docId = aSentence.getPid();
		TrainingPhraseModel trainModel;
		if(aSentenceModel!=null){
			argsListModels = aSentenceModel.getArgslist();
			if(argsListModels!=null){
				//for(ArgslistModel aa: argsListModels){
				for(int i = 0;i<argsListModels.size();i++){
					ArgslistModel aArgsList = argsListModels.get(i);

					argsModels = aArgsList.getArgsModels();
					if(argsModels !=null){
						
						//writeTitle(2);
						//Sheet phraseTab = getWorkBook().getSheet("phraseTab");
						//--------------------
						for(int j=0;j<argsModels.size();j++){
							trainModel = new TrainingPhraseModel(CommonMethod.UuidGenerator(),"batch_phrase");
							trainModel.setLevel(aArgsList.getlevel()+"");
							trainModel.setPredict(aArgsList.getpredict());
							trainModel.setPos(aArgsList.getpos());
							
							ArgsModel aArgs = argsModels.get(j);
							trainModel.setStartId(aArgs.getStartID());
							trainModel.setEndId(aArgs.getEndID());
							trainModel.setCore(aArgs.getCore());
							trainModel.setComponent(aArgs.getCom());
							trainModel.setArgs(aArgs.getArgs());
							trainModel.setPhrase(aArgs.getPhr());
							trainModel.setPhraseID(aArgs.getPhrID()+"");
							//CommonMethod.screenPrint("aArgs.getPhrID():"+aArgs.getPhrID()+",aArgs.getPaID():"+aArgs.getPaID());
							trainModel.setParentPhraseId(aArgs.getPaID()+"");
							trainModel.setSentenceId(sentenceId);
							trainModel.setDocId(docId);
							if(trainModel.getPredict()!=null && trainModel.getPredict().equals("analyze")){
								CommonMethod.screenPrint("predict:"+trainModel.getPredict()+",core:"+trainModel.getCore()+",component:"+trainModel.getComponent());
							}
							tmpList.add(trainModel);
						}
					}
				}
			}
		}
		
		//----------sort----------------
		ComparatorPhrase comparator=new ComparatorPhrase();
		Collections.sort(tmpList, comparator);
		//----------------------------
		
		int curLevel=0,tmpLevel,count=0;
		int ts,te,ss,se;
		//ArrayList<TrainingPhraseModel> initSameLevelModels = new ArrayList<TrainingPhraseModel>();
		ArrayList<TrainingPhraseModel> sameLevelModels = null;
		ArrayList<TrainingPhraseModel> upperLevelModels = null;
		for(TrainingPhraseModel aTmpPhrase:tmpList){
			tmpLevel = Integer.parseInt(aTmpPhrase.getLevel());
			if(curLevel!=tmpLevel){
				upperLevelModels = sameLevelModels;
				sameLevelModels = new ArrayList<TrainingPhraseModel>();
			}	
				
			if(upperLevelModels !=null){
				for(TrainingPhraseModel aSame:upperLevelModels)
				{
						ts = aTmpPhrase.getStartId();
						te = aTmpPhrase.getEndId();
						ss = aSame.getStartId();
						se = aSame.getEndId();
						if(ss<=ts && se>=te){//contains parent
							aTmpPhrase.setParentPhraseId(aSame.getPhraseID());
						}
				}
					
			}
			curLevel = tmpLevel;
			
			
			sameLevelModels.add(aTmpPhrase);
			curLevel = tmpLevel;
			
			if(!debugMode){
				dbA.saveTrainingPhrase(aTmpPhrase);
			}
		}//endof for
		
		flag=true;
		return flag;
	}

	//create documents for corpus from db  by given design view 
	private boolean createCorpusDocumentsFromDB(Corpus corpus,ArrayList<String> idList)throws MalformedURLException,ResourceInstantiationException{
		boolean rtn = false;
		DBAccess aDB = new  DBAccess();
		String sUrl = "";
		String dbBaseUrl = CommonMethod.getDbUrl();
		//http://10.1.62.239:5984/db-test4/01388b90_096f_4d56_929c_fecec6cdd1fe/Abstract.html
		//------------write output excel--------------
		for (String id: idList)
	    {
				sUrl = dbBaseUrl+id+"/Abstract.html";
		
		        if(sUrl !=null){
					FeatureMap params = Factory.newFeatureMap();
					params.put("sourceUrl", sUrl); //.../180c4bdc_6210_47f6_a3e4_69fd800359d7/RelatedWork.html
					params.put("preserveOriginalContent", new Boolean(true));
					params.put("collectRepositioningInfo", new Boolean(true));
					params.put("markupAware", new Boolean(true));
					params.put("encoding", "UTF-8");
					
					//Out.prln("Creating doc for " + u);
					Document tmpDoc = (Document)Factory.createResource("gate.corpora.DocumentImpl", params);
					//CommonMethod.screenPrint("uuid in document:"+tmpDoc.getParameterValue("uuid"));
					corpus.add(tmpDoc);
		        }
		}
		rtn = true;
		return rtn;
		
	}	
	
	
	//return pubmed id Array
	private ArrayList<String> preProcessDoc(){
		ArrayList<String> rtn = null;
		//------------search---------------
		PubmedDataInterface pubmed = new PubmedDataInterface();
		pubmed.setRetMax(100);
		try {
			removeAllDocModel();
			removeAllSentenceModel();
			removeAllPhraseModel();
			
			ArrayList<Citation> result = pubmed.processSearch(this.keyWords);
			if(result !=null){
				rtn = new ArrayList<String>();
				for(Citation aPaper: result){
					TrainingPaperModel aPModel = getTrainingPaperModel(aPaper);
					if(savePaperModel(aPModel)){
						rtn.add(aPModel.getId());
					}
				}
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return rtn;
	}
	
	
	private TrainingPaperModel getTrainingPaperModel(Citation aPaper){
		String resId;
		String docId =  CommonMethod.UuidGenerator(); //uuid
		String docType = "batch_paper";
		resId = aPaper.getResId();
		//String docType = "batch_paper_"+getDB();
		TrainingPaperModel tPaper = new TrainingPaperModel(docId,docType);
		tPaper.setPid(resId);
		tPaper.setTypeName(aPaper.getResType());
		tPaper.setTitle(aPaper.getTitle());
		tPaper.setAuthor(aPaper.getAuthor());
		
		
		//ArrayList<Citation> result = pubmed.processSearch(keyWords);
		//System.out.println("search result:"+result.size());

		return tPaper;
	}

	//-------------add required tags------------
	private HashSet getTagsForAnnotationSet(){
		HashSet rtn = new HashSet(); //annotTypesRequired
		//-----------
		rtn.add("Sentence");
		rtn.add("CA_PositiveStrongLinkTag");
		rtn.add("CA_NegativeStrongLinkTag");
		rtn.add("CA_PositiveWeakLinkTag");
		rtn.add("CA_NegativeWeakLinkTag");
		rtn.add("CA_NewRiskLinkTag");
	    //-------for test--
	    //rtn.add("Lookup");
		return rtn;
	}
	private String getDocKeyFromUrl(String strLink) {
		String lastPart = DBAccess.getSubStringFromDBURI(strLink); // id/Abstract.html
		lastPart = lastPart.substring(0, lastPart.indexOf("."));
		lastPart = lastPart.replace("/", "-");
		CommonMethod.screenPrint(lastPart);
		return lastPart;
	}
	public String saveTrainingPhrase(TrainingPhraseModel tpModel){
		CouchDBClientImpl impl = new CouchDBClientImpl();
		Response response = impl.save(tpModel);
		return response.getId();
	}
	
	public boolean removeAllPhraseModel(){
		String designView = "paper/batchPhrase";
		ArrayList<JsonObject> attList;
		Response response;
		boolean rtn = false;
		DBAccess dbA = new DBAccess();
		CouchDbClient dbClient = dbA.getDbClient();
		
		String dbUri = dbClient.getDBUri().toString();
		View paperAttachments = dbClient.view(designView);
		attList = (ArrayList)paperAttachments.query(JsonObject.class);
		String urlTmp,sId,sFileName;
		if(attList!=null){
			JsonObject aPaperPartDoc;
			TrainingPhraseModel pModel;
			JsonArray keyArr,valueArr;
			String hashKey,paperPortion;
			for(int i=0;i<attList.size();i++){
				aPaperPartDoc = (JsonObject)attList.get(i);
				sId = (String)aPaperPartDoc.get("id").getAsString();
				pModel = dbClient.find(TrainingPhraseModel.class,sId);
				response = dbClient.remove(pModel); 
			}
		}
		rtn = true;
		return rtn;
	}
	public boolean removeAllSentenceModel(){
		String designView = "paper/batchSentence";
		ArrayList<JsonObject> attList;
		Response response;
		boolean rtn = false;
		DBAccess dbA = new DBAccess();
		CouchDbClient dbClient = dbA.getDbClient();
		
		String dbUri = dbClient.getDBUri().toString();
		View paperAttachments = dbClient.view(designView);
		attList = (ArrayList)paperAttachments.query(JsonObject.class);
		String urlTmp,sId,sFileName;
		if(attList!=null){
			JsonObject aPaperPartDoc;
			TrainingSentenceModel sModel;
			JsonArray keyArr,valueArr;
			String hashKey,paperPortion;
			for(int i=0;i<attList.size();i++){
				aPaperPartDoc = (JsonObject)attList.get(i);
				sId = (String)aPaperPartDoc.get("id").getAsString();
				sModel = dbClient.find(TrainingSentenceModel.class,sId);
				response = dbClient.remove(sModel); 
			}
		}
		rtn = true;
		return rtn;
	}
	public ArrayList<TrainingPaperModel> readAllDoc(){
		String viewName = "paper/batchPaper";
		ArrayList<TrainingPaperModel> attList;
		CouchDBClientImpl clientImp = new CouchDBClientImpl();
		View paperView =  clientImp.view(viewName).includeDocs(true);
		//ArrayList<JsonObject> attList;
		attList = (ArrayList<TrainingPaperModel>)paperView.query(TrainingPaperModel.class);
		
		return attList;
		
	}
	public boolean removeAllDocModel(){
		String designView = "paper/batchPaper";//"paper/paperAttachment";
		ArrayList<JsonObject> attList;
		Response response;
		boolean rtn = false;
		DBAccess dbA = new DBAccess();
		CouchDbClient dbClient = dbA.getDbClient();
		
		String dbUri = dbClient.getDBUri().toString();
		View paperAttachments = dbClient.view(designView);
		attList = (ArrayList)paperAttachments.query(JsonObject.class);
		String urlTmp,sId,sFileName;
		if(attList!=null){
			JsonObject aPaperPartDoc;
			TrainingPaperModel tModel;
			JsonArray keyArr,valueArr;
			String hashKey,paperPortion;
			for(int i=0;i<attList.size();i++){
				aPaperPartDoc = (JsonObject)attList.get(i);
				sId = (String)aPaperPartDoc.get("id").getAsString();
				tModel = dbClient.find(TrainingPaperModel.class,sId);
				response = dbClient.remove(tModel); 
			}
		}
		rtn = true;
		return rtn;
	}
	public boolean batchUploadExcels(){
		boolean rtn = false;
		String docId;
		try {
		ArrayList<TrainingPaperModel> papers =readAllDoc();
		int i=0;
			for(TrainingPaperModel aPaper: papers){
					
				createExcelForAPaper(aPaper.getId(),i);
				i++;
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return rtn;
	}
	public boolean createExcelForAPaper(String docId, int i) throws IOException{
		boolean rtn = false;
		//-------------find model----------
		TrainingPaperModel tModel ;
		CouchDBClientImpl clientImp = new CouchDBClientImpl();
		tModel = clientImp.find(TrainingPaperModel.class, docId);

		ByteArrayOutputStream file = new ByteArrayOutputStream();
		writeExcel(file,docId);
		
		//------------test------------
		String outputExcel = "D:\\Output"+i+".xls";
		FileOutputStream outputStream = new FileOutputStream (outputExcel); 
		file.writeTo(outputStream);
		file.close();
		outputStream.close();
		
		//----attachment
		/*byte[] bytes = file.toByteArray() ;
	    String data = Base64.encodeBase64String(bytes);
	    Attachment attachment = new Attachment(data,"application/vnd.ms-excel");//(data, "text/plain");	
	    //Bar bar = new Bar(); 
	    tModel.addAttachment("Output.xls",attachment);
	    Response response = clientImp.update(tModel); //update
	    String id = response.getId();
	    */
	    //-----------
		rtn = true;
		return rtn;
	}
	
	public  TrainingSentenceModel readSentenceById(String sentenceId){
		TrainingSentenceModel rtn = null;
		
		CouchDBClientImpl clientImp = new CouchDBClientImpl();
		
		String viewName = "paper/batchSentence";
		View paperView =  clientImp.view(viewName).startKey(sentenceId).endKey(sentenceId).includeDocs(true);
		//ArrayList<JsonObject> attList;
		ArrayList<TrainingSentenceModel> attList;
		attList = (ArrayList)paperView.query(TrainingSentenceModel.class);
		if(attList!=null && attList.size()==1){
			CommonMethod.screenPrint("------------------sentence start:"+sentenceId+",endkey:"+sentenceId+"----------------------------");
			rtn = (TrainingSentenceModel)attList.get(0);
			
		}
		return rtn;
	}
	public  TrainingPaperModel readDocByDocId(String docId){
		TrainingPaperModel rtn =null;
		CouchDBClientImpl clientImp = new CouchDBClientImpl();
		
		String viewName = "paper/batchPaperKeyId";
		View paperView =  clientImp.view(viewName).startKey(docId).endKey(docId).includeDocs(true);
		//ArrayList<JsonObject> attList;
		ArrayList<TrainingPaperModel> attList;
		attList = (ArrayList)paperView.query(TrainingPaperModel.class);
		if(attList!=null && attList.size()==1){
			CommonMethod.screenPrint("------------------sentence start:"+docId+",endkey:"+docId+"----------------------------");
			rtn = (TrainingPaperModel)attList.get(0);
			
		}
		return rtn;
	}
	public ArrayList<TrainingSentenceModel> readSentenceOfDoc(String docId){
		ArrayList<TrainingSentenceModel> rtn;
		CouchDBClientImpl clientImp = new CouchDBClientImpl();
		String viewName = "paper/batchSentencePid";
		View sentenceView =  clientImp.view(viewName).startKey(docId).endKey(docId).includeDocs(true);//.startKey(startKey).endKey(endKey).includeDocs(true);
		//ArrayList<JsonObject> attList;
		rtn = (ArrayList<TrainingSentenceModel>)sentenceView.query(TrainingSentenceModel.class);
		CommonMethod.screenPrint(((TrainingSentenceModel)rtn.get(0)).toString());
		
		return rtn;
	}
	//http://10.1.62.239:5984/db-test6/_design/paper/_view/batchPhraseOfSentenceByDoc?startkey=[%220c19272a_bfe5_45ea_b80c_bc7b5494c614%22]&endkey=[%220c19272a_bfe5_45ea_b80c_bc7b5494c614%22,{}]
	public ArrayList<TrainingPhraseModel> readPhraseOfSentenceByDoc(String docId){
		ArrayList<TrainingPhraseModel> rtn;
		CouchDBClientImpl clientImp = new CouchDBClientImpl();
		String viewName = "paper/batchPhraseOfSentenceByDocId";
		
		View phraseView =  clientImp.view(viewName).key(docId).includeDocs(true);
		//View sentenceView =  clientImp.view(viewName).startKey(docId).endKey(docId,{}).includeDocs(true);//.startKey(startKey).endKey(endKey).includeDocs(true);
		//ArrayList<JsonObject> attList;
		rtn = (ArrayList<TrainingPhraseModel>)phraseView.query(TrainingPhraseModel.class);
		CommonMethod.screenPrint(((TrainingPhraseModel)rtn.get(0)).toString());
		
		return rtn;
	}	
	public ArrayList<TrainingPhraseModel> readPhraseByDocAndSentence(ArrayList<TrainingSentenceModel> docSentences ){
		ArrayList<TrainingPhraseModel> rtn = null;
		String pId,sId;
		if(docSentences!=null){
			rtn = new ArrayList<TrainingPhraseModel>();
			ArrayList<TrainingPhraseModel> tmpPhraseList = null;
			TrainingSentenceModel sModel ;
			TrainingPhraseModel pModel;
			for(TrainingSentenceModel aSentence: docSentences){
				pId = aSentence.getPid();//docId
				sId = aSentence.getId();//sentenceId
				sModel = this.readSentenceById(sId);
				pModel = new TrainingPhraseModel("");
				pModel.setId(sModel.getSentContent());
				rtn.add(pModel);//sentence Content
				//http://10.1.62.239:5984/db-test6/_design/paper/_view/batchPhraseOfSentenceByDoc?key=[%22063662f8_2a93_4022_821a_53d9c855c2e1%22,%2224f200c6_638c_4db5_a685_9b10e0ef072f%22]
				
				CouchDBClientImpl clientImp = new CouchDBClientImpl();
				String viewName = "paper/batchPhraseOfSentenceByDoc";

				View phraseView = clientImp.view(viewName).key(pId,sId).includeDocs(true);
				tmpPhraseList =  (ArrayList<TrainingPhraseModel>)phraseView.query(TrainingPhraseModel.class);
				rtn.addAll(tmpPhraseList);//phrases belong to this sentence of a doc
			}
		}
		return rtn;
	}
	public boolean  writeExcel(ByteArrayOutputStream file, String docId) throws IOException{
		boolean rtn = false;
		
		HSSFWorkbook wBook = new HSSFWorkbook();
		DBAccess dbA = new DBAccess();
		//--------write paper title
		Sheet sPaper = wBook.createSheet("paperTab");
		Row aRow = sPaper.createRow((short)0);
		aRow.createCell(0).setCellValue("paperId");
		aRow.createCell(1).setCellValue("forder");
		aRow.createCell(2).setCellValue("title");
		//-----------paper data---------------
		TrainingPaperModel pModel = readDocByDocId(docId);
		ArrayList<TrainingPaperModel> papers = new ArrayList<TrainingPaperModel>();
		papers.add(pModel);
		writePapers(papers, wBook);
		//----------write sentence title--------
		Sheet sSentence = wBook.createSheet("sentenceTab");//getWorkBook().getSheet("sentenceTab");
		Row  bRow = sSentence.createRow((short)0);
		bRow.createCell(0).setCellValue("sentenceId");
		bRow.createCell(1).setCellValue("paperId");
		bRow.createCell(2).setCellValue("portion");
		bRow.createCell(3).setCellValue("startId");
		bRow.createCell(4).setCellValue("endId");
		bRow.createCell(5).setCellValue("tagName");
		bRow.createCell(6).setCellValue("sentence");
		//-----------sentence data
		ArrayList<TrainingSentenceModel> docSentences = readSentenceOfDoc(docId);
		writeSentences(docSentences,wBook);
		//------------write phrase title-----------
		Sheet sPhrase = wBook.createSheet("phraseTab");
		Row cRow = sPhrase.createRow((short)0);
		cRow.createCell(0).setCellValue("PhraseId");
		cRow.createCell(1).setCellValue("SentenceId");
		cRow.createCell(2).setCellValue("startId");
		cRow.createCell(3).setCellValue("endId");
		cRow.createCell(4).setCellValue("predict");
		cRow.createCell(5).setCellValue("POS");
		cRow.createCell(6).setCellValue("component");
		cRow.createCell(7).setCellValue("core");
		cRow.createCell(8).setCellValue("args");
		cRow.createCell(9).setCellValue("phrase");
		cRow.createCell(10).setCellValue("phraseId");
		cRow.createCell(11).setCellValue("parentPhraseId");
		cRow.createCell(12).setCellValue("level");
		//------------phrase data
		ArrayList<TrainingPhraseModel> phrases = readPhraseOfSentenceByDoc(docId) ;
		writePhrases("phraseTab",phrases,wBook);
		//--------------write phraseSentenceCombiTab
		Sheet spSentence = wBook.createSheet("phraseSentenceCombiTab");
		Row dRow = spSentence.createRow((short)0);
		dRow.createCell(0).setCellValue("PhraseId");
		dRow.createCell(1).setCellValue("SentenceId");
		dRow.createCell(2).setCellValue("startId");
		dRow.createCell(3).setCellValue("endId");
		dRow.createCell(4).setCellValue("predict");
		dRow.createCell(5).setCellValue("POS");
		dRow.createCell(6).setCellValue("component");
		dRow.createCell(7).setCellValue("core");
		dRow.createCell(8).setCellValue("args");
		dRow.createCell(9).setCellValue("phrase");
		dRow.createCell(10).setCellValue("phraseId");
		dRow.createCell(11).setCellValue("parentPhraseId");
		dRow.createCell(12).setCellValue("level");
		//------------phraseSentence data---------
		ArrayList<TrainingPhraseModel> senPhrases = readPhraseByDocAndSentence(docSentences);
		writePhrases("phraseSentenceCombiTab",senPhrases,wBook);
		//--------------write wordSentenceCombiTab
		Sheet aWord = wBook.createSheet("wordSentenceCombiTab");
		Row eRow = aWord.createRow((short)0);
		eRow.createCell(0).setCellValue("SentenceId");
		eRow.createCell(1).setCellValue("WordId");
		eRow.createCell(2).setCellValue("Word");
		eRow.createCell(3).setCellValue("WordLemma");
		eRow.createCell(4).setCellValue("ToId");
		eRow.createCell(5).setCellValue("ToWord");
		eRow.createCell(6).setCellValue("ToLemma");
		eRow.createCell(7).setCellValue("Relation");
		//-----------wordSentence data
		writeWordsForSentence("wordSentenceCombiTab",docSentences,wBook);

		wBook.write(file);
		
		//file.close();
		
		rtn = true;
        return rtn;

}
	public void writeWordsForSentence(String tabName,ArrayList<TrainingSentenceModel> sentDocList,HSSFWorkbook wBook){
		int wordRowcount = 1;
		try {
				 Sheet sWords = wBook.getSheet(tabName);
				if(sentDocList !=null){
				 //------------write output excel--------------
				 ClearnlpDecode cdInstance = ClearnlpDecode.getInstance();
				 for(int i=0;i<sentDocList.size();i++){
					 TrainingSentenceModel sModel = (TrainingSentenceModel)sentDocList.get(i);
					 String sId = sModel.getId();
					 String content = sModel.getSentContent();
					//--------DR process one sentence a time----------
					SentenceRelationModel aSentenceModel = cdInstance.process( content);// one sentence
					ArrayList<SentenceWordModel> wordModels = aSentenceModel.getTheSentence();
					int wordSize = wordModels.size();
					SentenceWordModel tmpWordModel,sHeadWrodModel;
					//-----------output one line here
					Row wRow = sWords.createRow(wordRowcount);
					wRow.createCell(0).setCellValue(content);//phraseId
					wordRowcount++;
					for (int j=0;j<wordSize;j++) //loop word ArrayList
					{
						tmpWordModel = (SentenceWordModel)wordModels.get(j);
						//---------for each word write one line.
						wRow = sWords.createRow(wordRowcount);
						wRow.createCell(0).setCellValue(sId);//sId
						wRow.createCell(1).setCellValue(tmpWordModel.getId());//wordId
						wRow.createCell(2).setCellValue(tmpWordModel.getRaw());//raw
						wRow.createCell(3).setCellValue(tmpWordModel.getLemma());//lemma
						String pHead = tmpWordModel.getPhead();
						wRow.createCell(4).setCellValue(pHead);//pHead
						int ipHead = Integer.parseInt(pHead);
						if(ipHead>0)
						{sHeadWrodModel = (SentenceWordModel)wordModels.get(ipHead-1);
							wRow.createCell(5).setCellValue(sHeadWrodModel.getRaw());//pHeadWord
							wRow.createCell(6).setCellValue(sHeadWrodModel.getLemma());//pHeadWord
						}
						wRow.createCell(7).setCellValue(tmpWordModel.getDeprel());//relation
						wordRowcount++;
					}//end of for words
						
					//-----------invoke eric's method to write Excel/DB
				 }//end of for sentence
					
					//wBook.write(file);
				
			 }//end of if
		}catch (  IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
					//------------write output excel--------------
	}
	public void writePapers(ArrayList<TrainingPaperModel> papDocList,HSSFWorkbook wBook){
			int paperRowcount = 1;
		try {	 
			Sheet pSheet = wBook.getSheet("paperTab");
					//------------write output excel--------------
				 for(int i=0;i<papDocList.size();i++){
					 TrainingPaperModel teModel = (TrainingPaperModel)papDocList.get(i);
				    CommonMethod.screenPrint(teModel.toString());
					Row pRow = pSheet.createRow(paperRowcount);
					pRow.createCell(0).setCellValue(teModel.getPId());//pid
					pRow.createCell(1).setCellValue(teModel.getTypeName());//FolderName
					pRow.createCell(2).setCellValue(teModel.getTitle());//title
					paperRowcount++;
				 }
				 
				
				 //wBook.write(file);
				 //file.close();
				 
			}//endof if
			 
		catch(Exception e){
				CommonMethod.screenPrint("in writePapers:"+e.getMessage());
		}
	}
	
	public void writeSentences(ArrayList<TrainingSentenceModel> sentDocList,HSSFWorkbook wBook){
		try {
			int sentenceRowCount = 1;	
			Sheet sSheet = wBook.getSheet("sentenceTab");
			if(sentDocList!=null && sentDocList.size()>0){
				//------------write output excel--------------
				 for(int i=0;i<sentDocList.size();i++){
					 TrainingSentenceModel sModel = (TrainingSentenceModel)sentDocList.get(i);
				    CommonMethod.screenPrint(sModel.toString());
					Row sRow = sSheet.createRow(sentenceRowCount);
			
					sRow.createCell(0).setCellValue(sModel.getId());//sId
					sRow.createCell(1).setCellValue(sModel.getPid());//pid
					sRow.createCell(2).setCellValue(sModel.getPapPortion());//Abstract
					sRow.createCell(3).setCellValue(sModel.getStartId());
					sRow.createCell(4).setCellValue(sModel.getEndId());
					sRow.createCell(5).setCellValue(sModel.getSentContent());
					sentenceRowCount++;
				 }
				//wBook.write(file);
			}//endof if
		}
		catch(Exception e){
				
		}
	}	
	

	
	public void writePhrases(String tabName,ArrayList<TrainingPhraseModel> phrasesList,HSSFWorkbook wBook){
		int phraseRowCount = 1;
		 Sheet sPhrase = wBook.getSheet(tabName);
			//------------write output excel--------------
		 if(phrasesList!=null && phrasesList.size()>0){
			 for(int i=0;i<phrasesList.size();i++){
				TrainingPhraseModel pModel = (TrainingPhraseModel)phrasesList.get(i);
			    CommonMethod.screenPrint(pModel.toString());
				Row pRow = sPhrase.createRow(phraseRowCount);
	
				pRow.createCell(0).setCellValue(pModel.getId());//phraseId
				pRow.createCell(1).setCellValue(pModel.getSentenceId());//sid
				pRow.createCell(2).setCellValue(pModel.getStartId());//Abstract
				pRow.createCell(3).setCellValue(pModel.getEndId());
				pRow.createCell(4).setCellValue(pModel.getPredict());
				pRow.createCell(5).setCellValue(pModel.getPos());
				pRow.createCell(6).setCellValue(pModel.getComponent());
				pRow.createCell(7).setCellValue(pModel.getCore());
				pRow.createCell(8).setCellValue(pModel.getArgs());
				pRow.createCell(9).setCellValue(pModel.getPhrase());
				pRow.createCell(10).setCellValue(pModel.getPhraseID());
				pRow.createCell(11).setCellValue(pModel.getParentPhraseId());
				pRow.createCell(12).setCellValue(pModel.getLevel());
				phraseRowCount++;
				
			 }
			 try {
				//wBook.write(file);
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		 }//end of if
	}
	/*public HSSFWorkbook writeExcel(){
			HSSFWorkbook rtn;
			rtn = new HSSFWorkbook();
	        HSSFSheet sheet = rtn.createSheet("Sample sheet");
	         
	        Map<String, Object[]> data = new HashMap<String, Object[]>();
	        data.put("1", new Object[] {"Emp No.", "Name", "Salary"});
	        data.put("2", new Object[] {1d, "John", 1500000d});
	        data.put("3", new Object[] {2d, "Sam", 800000d});
	        data.put("4", new Object[] {3d, "Dean", 700000d});
	         
	        Set<String> keyset = data.keySet();
	        int rownum = 0;
	        for (String key : keyset) {
	            Row row = sheet.createRow(rownum++);
	            Object [] objArr = data.get(key);
	            int cellnum = 0;
	            for (Object obj : objArr) {
	                Cell cell = row.createCell(cellnum++);
	                if(obj instanceof Date) 
	                    cell.setCellValue((Date)obj);
	                else if(obj instanceof Boolean)
	                    cell.setCellValue((Boolean)obj);
	                else if(obj instanceof String)
	                    cell.setCellValue((String)obj);
	                else if(obj instanceof Double)
	                    cell.setCellValue((Double)obj);
	            }
	        }
	        return rtn;

	}*/
	public void writeTitle(int i){
		String outputExcel = "c:\\test.xls";
		try {
			HSSFWorkbook workbook;
			 File file = new File(outputExcel);
			 boolean fileFlag = false;
			 FileInputStream fileIs = null;
			 if(file.exists()){
				 //Get the workbook instance for XLS file 
				 fileIs = new FileInputStream(file);
				 workbook = new HSSFWorkbook(fileIs);
				 fileFlag = true;
			 }else{
				 workbook = new HSSFWorkbook();
			 }
			//Get the workbook instance for XLS file 
			if(i==0){
				Sheet aPaper = workbook.createSheet("paperTab");
				Row aRow = aPaper.createRow((short)0);
				aRow.createCell(0).setCellValue("paperId");
				aRow.createCell(1).setCellValue("forder");
				aRow.createCell(2).setCellValue("title");
			}else if(i==1){
				Sheet aSentence = workbook.createSheet("sentenceTab");//getWorkBook().getSheet("sentenceTab");
				Row  bRow = aSentence.createRow((short)0);
				bRow.createCell(0).setCellValue("sentenceId");
				bRow.createCell(1).setCellValue("paperId");
				bRow.createCell(2).setCellValue("portion");
				bRow.createCell(3).setCellValue("startId");
				bRow.createCell(4).setCellValue("endId");
				bRow.createCell(5).setCellValue("tagName");
				bRow.createCell(6).setCellValue("sentence");
			}else if(i==2){
				Sheet aPhrase = workbook.createSheet("phraseTab");
				Row cRow = aPhrase.createRow((short)0);
				cRow.createCell(0).setCellValue("PhraseId");
				cRow.createCell(1).setCellValue("SentenceId");
				cRow.createCell(2).setCellValue("startId");
				cRow.createCell(3).setCellValue("endId");
				cRow.createCell(4).setCellValue("predict");
				cRow.createCell(5).setCellValue("POS");
				cRow.createCell(6).setCellValue("component");
				cRow.createCell(7).setCellValue("core");
				cRow.createCell(8).setCellValue("args");
				cRow.createCell(9).setCellValue("phrase");
				cRow.createCell(10).setCellValue("phraseId");
				cRow.createCell(11).setCellValue("parentPhraseId");
				cRow.createCell(12).setCellValue("level");
				
			}else if(i==3){
				Sheet aPhrase = workbook.createSheet("phraseSentenceCombiTab");
				Row cRow = aPhrase.createRow((short)0);
				cRow.createCell(0).setCellValue("PhraseId");
				cRow.createCell(1).setCellValue("SentenceId");
				cRow.createCell(2).setCellValue("startId");
				cRow.createCell(3).setCellValue("endId");
				cRow.createCell(4).setCellValue("predict");
				cRow.createCell(5).setCellValue("POS");
				cRow.createCell(6).setCellValue("component");
				cRow.createCell(7).setCellValue("core");
				cRow.createCell(8).setCellValue("args");
				cRow.createCell(9).setCellValue("phrase");
				cRow.createCell(10).setCellValue("parentPhraseId");
				cRow.createCell(11).setCellValue("level");
			}else if(i==4){
				Sheet aWord = workbook.createSheet("wordSentenceCombiTab");
				Row cRow = aWord.createRow((short)0);
				cRow.createCell(0).setCellValue("SentenceId");
				cRow.createCell(1).setCellValue("WordId");
				cRow.createCell(2).setCellValue("Word");
				cRow.createCell(3).setCellValue("WordLemma");
				cRow.createCell(4).setCellValue("ToId");
				cRow.createCell(5).setCellValue("ToWord");
				cRow.createCell(6).setCellValue("ToLemma");
				cRow.createCell(7).setCellValue("Relation");
			}
			if(fileFlag){
				fileIs.close();
			}
			FileOutputStream out;
		
			out = new FileOutputStream(new File(outputExcel));
			workbook.write(out);
			out.close();
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}catch (IOException e) {
		    e.printStackTrace();
		}
		   
	}
	public void test(){
		ArrayList<TrainingPaperModel> papers = this.readAllDoc();
		//ArrayList<TrainingPhraseModel> phrases = readPhraseOfSentenceByDoc("0c19272a_bfe5_45ea_b80c_bc7b5494c614");
		/*
		TrainingSentenceModel aSentence = readSentenceById("d2bbda38_29d7_45a1_979c_27f7d728e7da");
		String docId = aSentence.getPid();*/
		CommonMethod.screenPrint("size:"+papers.size());
	}
	
}

